// POKER2X 
// COPYRIGHT BY DAVE N
//
// I'm sorry for the fact that the code is just this file. When I started this project I got an old compiler which somehow
// wasn't able to manage multiple files. And when I got the new one, I was too lazy to change it, so it's still like this.
// A good code editor should automatically detect the functions and give you the option to jump to them, so that shouldn't
// be a too big problem. =)
//
// I'm using a mac so the makefile has got to be changed a lot to make this compile on any other system. I'm usually compiling
// with XCode which uses a completly other way to compile things than a makefile, the makefiles just was written in a minute
// so don't expect it to work flawlessly with every sdk installation.
//
// There *should* be a comment line before every function and class that explains what to do.
//
// Main starts at line 4130



#define GP2X_BUTTON_UP              (0)
#define GP2X_BUTTON_DOWN            (4)
#define GP2X_BUTTON_LEFT            (2)
#define GP2X_BUTTON_RIGHT           (6)
#define GP2X_BUTTON_CLICK           (18)
#define GP2X_BUTTON_A               (12)
#define GP2X_BUTTON_B               (13)
#define GP2X_BUTTON_Y               (14)
#define GP2X_BUTTON_X               (15)
#define GP2X_BUTTON_L               (10)
#define GP2X_BUTTON_R               (11)
#define GP2X_BUTTON_START           (8)
#define GP2X_BUTTON_SELECT          (9)
#define GP2X_BUTTON_VOLUP           (16)
#define GP2X_BUTTON_VOLDOWN         (17)

// Define the basic variables. These will stay like this if you aren't using a gp2x, so changing them won't affact any aspect of the gameplay on a gp2x
bool GP2X = false;
bool play_music;
bool btournament = true;
bool call_blinds = true;

//Include the headers
#include "SDL/SDL.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_ttf.h"
#include "SDL/SDL_mixer.h"
#include <string>

#include <fstream>
#include <iostream>
#include <sstream>


using namespace std;

// Uncomment the next line to write to a log file.
// ofstream cout("log.txt", ios::out);

SDL_Event event;




//The attributes of the screen
const int SCREEN_WIDTH = 320;
const int SCREEN_HEIGHT = 240;
const int SCREEN_BPP = 16;

SDL_Surface *screen = NULL;
SDL_Surface *card_surface = NULL;
SDL_Surface *background_surf = NULL;
SDL_Surface *action_surf = NULL;
SDL_Surface *text = NULL;
SDL_Surface *results_surf = NULL;
SDL_Surface *dealer_surf = NULL;

//The card class.
struct card
{
	int wert; // Value of the card
	string sorte; // Which kind.
	string wert_txt; // Value of the card written out.
	SDL_Rect sprite_pos;
};

// Coordinate class.
struct coordinate
{
	int x;
	int y;
};

std::string backgrounds[20];
std::string cardsets[10];
std::string music_tracks[20];
int back_count = 0;
int card_count = 0;
int music_count = 0;
int music_volume = 50;
int current_song = 0;
int delay = 50;
int played_hands = 0;


ifstream config_file("data/config.txt");


//Variablen frs Spiel:
card card_base[52];
int small_blind = 5;
int big_blind = 10;
int low_limit = 10;
int high_limit = 20;
int players_count = 8;
int start_money = 500;
int current_round = 0;
string players_name = "You";
bool check_not_call = false;

int dealer = 0;
int payer_small = dealer + 1;
int payer_big = payer_small + 1;

TTF_Font *font;
TTF_Font *font_bigger;

Mix_Music *music = NULL;

bool goto_menu = false;

// The default files that get loaded if you aren't running this on a gp2x.
string card_file = "data/cards_R7i1c3K.gif";
string background_file = "data/back_fusion_power.png";
string font_file = "data/FreeSansOblique.ttf";
string font_file_big = "data/FreeSansBold.ttf";
string splash_file = "data/splash_by_AcidiC.jpg";
string action_file = "data/action_icons.png";
string results_file = "data/results_fusion_power.png";
string dealer_file = "data/dealer.png";

coordinate cord_en_c[7];
coordinate cord_pl_c[2];
coordinate cord_com_c[5];
coordinate cord_but_txt[3];
coordinate cord_pl1_txt[3];
coordinate cord_en_name[7];
coordinate cord_money_pot;
coordinate cord_en_money[7];
coordinate cord_en_bet[7];

SDL_Rect en_cards[2];

int draw_graphics(string, int);
void draw_cards();
int draw_text(string, TTF_Font*);
void fold_players(int);
void blit( int , int , SDL_Surface* , SDL_Surface* , SDL_Rect*  );
void blit_text( string , int , int , TTF_Font *);
SDL_Surface *load_image( string ) ;



string ai_names[43];


//----------------------------------------------------------------------
//----------------------------------------------------------------------

// NOW THE UGLY PART OF THE CODE WILL FOLLOW

//----------------------------------------------------------------------
//----------------------------------------------------------------------















//----------------------------------------------------------------------
//----------------------------------------------------------------------
//   FUNCTIONS THAT WILL DO CARD THINGS ARE FOLLOWING HERE
//----------------------------------------------------------------------
//----------------------------------------------------------------------


// -----------------------------------------------
//
// Function that builds the card base. It actually just generates all the cards with their variables and then adds them to the card_base array.

void build_card_base()
{
	
	int temp = 1;
	int temp2 = 0; 
	int temp3 = 0;
	while (temp<=4)
	{	
		while (temp2 <= 12)
		{
			switch (temp)
			{
				case 1 : 
				card_base[temp3].sorte = "Pik"; 
				card_base[temp3].sprite_pos.y = 117;
				break;
				case 2 : 
				card_base[temp3].sorte = "Kreuz"; 
				card_base[temp3].sprite_pos.y = 78;
				break;
				case 3 : 
				card_base[temp3].sorte = "Herz"; 
				card_base[temp3].sprite_pos.y = 0;
				break;
				case 4 : 
				card_base[temp3].sorte = "Karo"; 
				card_base[temp3].sprite_pos.y = 39;
				break;
			};
			card_base[temp3].sprite_pos.w = 27;
			card_base[temp3].sprite_pos.h = 39;
			card_base[temp3].wert = temp2;
			switch (temp2)
			{
				case 0 : 
					card_base[temp3].wert_txt = "Zwei"; 
					card_base[temp3].sprite_pos.x = 324;
				break;
				case 1 : 
					card_base[temp3].wert_txt = "Drei";
					card_base[temp3].sprite_pos.x = 297; 
				break;
				case 2 : 
					card_base[temp3].wert_txt = "Vier";
					card_base[temp3].sprite_pos.x = 270; 
				break;
				case 3 : 
					card_base[temp3].wert_txt = "Fuenf";
					card_base[temp3].sprite_pos.x = 243; 
				break;
				case 4 : 
					card_base[temp3].wert_txt = "Sechs"; 
					card_base[temp3].sprite_pos.x = 216;
				break;
				case 5 : card_base[temp3].wert_txt = "Sieben"; 
					card_base[temp3].sprite_pos.x = 189;
				break;
				case 6 : 
					card_base[temp3].wert_txt = "Acht"; 
					card_base[temp3].sprite_pos.x = 162;
				break;
				case 7 : 
					card_base[temp3].wert_txt = "Neun"; 
					card_base[temp3].sprite_pos.x = 135;
				break;
				case 8 : 
					card_base[temp3].wert_txt = "Zehn"; 
					card_base[temp3].sprite_pos.x = 108;
				break;
				case 9 : 
					card_base[temp3].wert_txt = "Bube"; 
					card_base[temp3].sprite_pos.x = 81;
				break;
				case 10 : 
					card_base[temp3].wert_txt = "Dame"; 
					card_base[temp3].sprite_pos.x = 54;
				break;
				case 11 : 
					card_base[temp3].wert_txt = "Koenig"; 
					card_base[temp3].sprite_pos.x = 27;
				break;
				case 12 : 
					card_base[temp3].wert_txt = "Ass"; 
					card_base[temp3].sprite_pos.x = 0;
				break;
			};
			temp2 = temp2 + 1;
			
			//::cout<<"card_base["<<temp3<<"] = "<<card_base[temp3].sorte<<" "<<card_base[temp3].wert_txt<<endl;
			
			temp3 = temp3 + 1;
		};
		
		temp = temp + 1;
		temp2 = 0;
	};
};


// -----------------------------------------------
//
// Shuffling. Function that generates a random deck. It uses SDL_GetTicks() to get a value that will get used by srand to get a new random deck everytime.
// Maybe SDL_GetTicks() will get replaced with another time-getting function.

card* build_deck()
{
    int temp = 0;
	int temp2 = 0, temp3 = 0;
	int used_cards[52];
	card *deck = new card[52];

    srand( SDL_GetTicks() );
	
	while (temp2 < 52 )
	{
        temp = (int)((double)rand()*52/RAND_MAX); 
		temp3 = 0;
		while ( temp3 < temp2 ) 
		{
			if ( temp == used_cards[temp3] ) {
				temp3 = 60;
			} else {
				temp3 = temp3 + 1;
			};
		}
		
		if (temp3 == 60 )
		{     
			
		} else {
			deck[temp2] = card_base[temp];
			used_cards[temp2] = temp;
			temp2 = temp2 + 1;
		};
		
	};
	return deck;
	
};

//----------------------------------------------------------------------
//----------------------------------------------------------------------
//   FUNCTIONS THAT HAVE TO DO THINGS WITH ANALYZING HANDS WILL FOLLOW HERE
//----------------------------------------------------------------------
//----------------------------------------------------------------------


// -----------------------------------------------
//
// Function that calculates the points of a given hand. If output is set to true, it will print the points with all the cards to the terminal.

int get_points(card hand[7], bool output = true, int anz_cards = 7, bool return_type = false)
{
	::cout<<"Reached Get Points"<<endl;
	int temp = 0;
	bool paare = false, zweipaare = false, dreier = false, Straight = false, flush = false, fullhouse = false, vierer = false, straightflush = false;
	int again = -1;
	signed int points = 0;
	int kickpaar = 0, kickpaar2 = 0,kicker = hand[anz_cards - 1].wert;
	int hande = 0;
	
	// -------------------
	// Nach Paaren suchen
	// -------------------
	temp = (anz_cards - 1);
	::cout<<"Reached Paare suchen"<<endl;
	while (temp >=  0)
	{
		if ( hand[temp].wert == hand[temp - 1].wert )
		{
			// Paar gefunden 
			paare = true;
			again = temp - 1;
			kickpaar = hand[temp].wert;
			kicker = hand[temp - 2].wert;
			
			if ( hand[temp].wert == hand[temp - 2].wert && temp - 2 >= 0 ) 
			{
				// Dreier gefunden
				dreier = true;
				paare = false;
				again = temp - 2;
				
				
				if ( hand[temp].wert == hand[temp - 3].wert && temp - 3 >= 0 ) 
				{
					// Vierer gefunden
					vierer = true;
					dreier = false;
					paare = false;
					again = 7;
				};
			};
			temp = -1;
		};
		temp = temp - 1;
	};
	
	if ( again < anz_cards - 1 )
	{
		
		temp = again - 1;
		while (temp >= 0)
		{
			if ( hand[temp].wert == hand[temp - 1].wert && temp - 1 >= 0  )
			{
				kickpaar2 = hand[temp].wert;
				if ( dreier == true ) 
				{
					fullhouse = true;
					dreier = false;
					
				};
				
				if ( paare == true ) 
				{
					zweipaare = true;
					paare = false;
					
					
					
					if ( hand[temp].wert == hand[temp - 2].wert && temp - 2 >= 0  ) 
					{
						// 2Dreier gefunden
						zweipaare = false;
						fullhouse = true;
					};
				};
			};
			temp = temp - 1;
		};
		
	};
	
	// -----------------
	// Nach Flush suchen
	//
	::cout<<"Reached Flush suchen"<<endl;
	temp = 0;
	int pik = 0, kreuz = 0, herz = 0, karo = 0;
	
	while (temp < anz_cards)
	{
		if ( hand[temp].sorte == "Pik" ) {  pik = pik + 1; };
		if ( hand[temp].sorte == "Kreuz" ) {  kreuz = kreuz + 1;};
		if ( hand[temp].sorte == "Herz" ) {  herz = herz + 1; };
		if ( hand[temp].sorte == "Karo" ) {  karo = karo + 1;};
		temp = temp + 1;
		
	};
	if (pik >= 5 )
	{
		flush = true;
	};
	if ( karo >= 5)
	{
		flush = true;
	};
	if (kreuz >= 5 )
	{
		flush = true;
	};
	if ( herz >= 5)
	{
		flush = true;
	};
	
	// ----------------
	// Strasse erkennen
	//
	::cout<<"Reached Strasse suchen"<<endl;
	
	int temp2 = 0;
	bool temp_hand[13];
	temp = 0;
	while ( temp <= 12 ) {
		temp_hand[temp] = false;
		temp = temp + 1;
	};
	temp = 0;

	while (temp < anz_cards)
	{
		while (temp2 <= 12) {
			if (hand[temp].wert == temp2) 
			{ 
				temp_hand[temp2] = true;
			};
			temp2 = temp2 + 1;
		};
		temp = temp + 1;
		temp2 = 0;
	};
	
	temp = 0;
	while (temp <= 8)
	{
		if (temp_hand[temp] == true )
		{ if (temp_hand[temp + 1] == true) 
		{ if (temp_hand[temp + 2] == true )
		{ if (temp_hand[temp + 3] == true) 
		{ if (temp_hand[temp + 4] == true )
		{
			::cout<<"Strasse: "<<temp<<","<<temp + 1<<","<<temp + 2<<","<<temp + 3<<","<<temp + 4<<","<<endl<<endl;
			if ( flush == true) {
			straightflush = true;
			flush = false;
			} else {
			Straight = true;
			};
			kickpaar = temp + 4;
			temp = 10;
		} else if ( temp == 0 && temp_hand[12] == true ) {
			::cout<<"Strasse: "<<temp<<","<<temp + 1<<","<<temp + 2<<","<<temp + 3<<","<<12<<","<<endl<<endl;
			if ( flush == true) {
				straightflush = true;
				flush = false;
			} else {
				Straight = true;
			};
			kickpaar = temp + 4;
			temp = 10;
		};
			
		};
		};
		};
		};
		temp = temp + 1;
	};
	
	
	
	
	
	
	
	
	//-----------------
	// Punkte berechnen
	//
	::cout<<"Reached Punkte berechnend"<<endl;
	kicker = hand[anz_cards - 1].wert;
	::cout<<"Kicker: "<<kicker<<endl;
	
	if (!return_type) {
	::cout<<"Returning points, not type"<<endl;			
	points = kicker*10000 + hand[anz_cards - 2].wert*1000 + hand[4].wert*100 + hand[3].wert*10 + hand[2].wert - 1000000000;
	};
	
	hande = 0;
	if ( paare == true ) 
	{
	::cout<<"Paare found"<<endl;
		if (!return_type) {
			::cout<<"Returning points, not type"<<endl;			
			points = kickpaar * 140000 + kicker*10000 + hand[anz_cards - 2].wert*1000 + hand[4].wert*100 + hand[3].wert*10 + hand[2].wert*1 - 100000000 ;
		};
		// MIN: 34
		// MAX: 194
		::cout<<"Vor Hande"<<endl;
		hande = 1;
		::cout<<"Nach Hande"<<endl;
	};
	
	if ( zweipaare == true )
	{
		::cout<<"2 Paare found"<<endl;
		if (!return_type) {
			::cout<<"Returning points, not type"<<endl;			points =  kickpaar * 15000000 + kickpaar2 * 1400000 + kicker*10000 + hand[anz_cards - 2].wert*1000 + hand[4].wert*100 + hand[3].wert*10 + hand[2].wert;
		};
		// MIN: 200
		// MAX: ca. 90'000
		hande = 2;
		
	};
	
	if ( dreier == true ) 
	{
		::cout<<"Trips found"<<endl;
		if (!return_type) {
			::cout<<"Returning points, not type"<<endl;			
			points = kickpaar * 14000000 + kicker*100000 + hand[anz_cards - 2].wert*10000 + hand[4].wert*1000 + hand[3].wert*100 + hand[2].wert*10 + hand[1].wert + 1200000000 ;
		};
		hande = 3;
		::cout<<"Nach Hande"<<endl;
		
	};
	
	if ( Straight == true ) 
	{
		::cout<<"Straight found"<<endl;
		if (!return_type) {
			::cout<<"Returning points, not type"<<endl;			
			points = kickpaar*1000000 + hand[anz_cards - 1].wert*100000 + hand[anz_cards - 2].wert*10000 + hand[anz_cards - 3].wert*1000 + hand[2].wert*100 + hand[1].wert*10 + hand[0].wert + 1300000000;
		};
		hande = 4;
		::cout<<"Nach Hande"<<endl;
		
	};
	
	if ( flush == true ) 
	{
		::cout<<"Flush found"<<endl;
		if (!return_type) {
			::cout<<"Returning points, not type"<<endl;			
			points = kicker*1000000 + hand[anz_cards - 2].wert*100000 + hand[4].wert*10000 + hand[3].wert*1000 + hand[2].wert*100 + hand[1].wert*10 + hand[0].wert + 1400000000;
		};
		hande = 5;
		::cout<<"Nach Hande"<<endl;
	};	
	
	if ( fullhouse == true ) 
	{
		::cout<<"FullHouse found"<<endl;
		if (!return_type) {
			::cout<<"Returning points, not type"<<endl;			
			points =  kickpaar2 * 15000000 + kickpaar * 1400000 + kicker*10000 + hand[anz_cards - 2].wert*1000 + hand[4].wert*100 + hand[3].wert*10 + hand[2].wert + 1623145804;
		};
		hande = 6;
		::cout<<"Nach Hande"<<endl;
	};			
	
	if ( vierer == true ) 
	{
		::cout<<"Quads found"<<endl;
		if (!return_type) {
			::cout<<"Returning points, not type"<<endl;			
			points = kickpaar * 1400000 + 2000000000;
		};
		hande = 7;
		::cout<<"Nach Hande"<<endl;
		
	};
	
	if (straightflush == true)
	{
		::cout<<"Straight Flush found!"<<endl;
		if (!return_type) {
			::cout<<"Returning points, not type"<<endl;			
			points = kicker + 210000000;
		};
		hande = 8;
		::cout<<"Nach Hande"<<endl;
		
	};
	
	
		::cout<<endl<<hande<<endl;
		::cout<<hand[0].sorte<<" "<<hand[0].wert_txt<<" | "<<hand[1].sorte<<" "<<hand[1].wert_txt<<" | "<<hand[2].sorte<<" "<<hand[2].wert_txt<<" | "<<hand[3].sorte<<" "<<hand[3].wert_txt<<" | "<<hand[4].sorte<<" "<<hand[4].wert_txt<<" | "<<hand[anz_cards - 2].sorte<<" "<<hand[anz_cards - 2].wert_txt<<" | "<<hand[anz_cards - 1].sorte<<" "<<hand[anz_cards - 1].wert_txt<<endl;
	
	
	if (return_type) {
		return hande;
	};
	return points;
	
	
};

//----------------------------------------------------------------------
//----------------------------------------------------------------------
//   CLASSES WILL FOLLOW HERE
//----------------------------------------------------------------------
//----------------------------------------------------------------------


// -----------------------------------------------
//
// The player class. 

class player
{
public:
	int money; // Amount of money the player has.
	int einsatz; // How much money he's thrown in the pot.
	bool has_betted; // Has he already interacted with the pot in this round?
	card cards[7]; // His complete hand with the community cards.
	card eigen[2]; // His private cards.
	int	cardcount; // Necessary for adding the cards to his hand.
	bool is_in; // Is he still in at the actual round?
	bool is_ai; // Is the player a computer?
	int use_ai; // The ai the player should use.
	int points;
	string name;
	string last_action;
	
	player () {
		money = 0;
		einsatz = 0;
		has_betted = false;
		cardcount = 0;
		is_in = true;
		is_ai = false;
		use_ai = 0;
		points = 0;
		name = "";
		last_action = " ";
	};
	
	// -----------------------------------------------
	// Function that get's the input of the player. HAS TO BE CHANGED ACCORDING TO THE OS THIS RUNS ON.
	string get_action(TTF_Font *font, TTF_Font *font_bigger)
	{
		draw_graphics("Background",0);
		draw_text("Buttons", font);
		draw_text("Player Stats", font_bigger);
		draw_text("Money in Pot", font_bigger);
		draw_text("Enemy Stats", font);
		draw_graphics("Enemy Cards",0);
		draw_cards();
		
		fold_players(9);
		SDL_Flip(screen);	
		char temp;
		if (GP2X) {
		::cout<<"Waits on GP2X action button..."<<endl;
			bool received = false;
			while(!received) {
				while (SDL_PollEvent(&event))
				{
					switch (event.type)
					{
						case SDL_JOYBUTTONDOWN:
							switch(event.jbutton.button)
							{
								case GP2X_BUTTON_A:
									::cout<<"A Pressed"<<endl;
									received = true;
									temp = 'f';
									break;
								case GP2X_BUTTON_Y:
									::cout<<"Y Pressed"<<endl;
									received = true;
										temp = 'k';
										temp = 'c';
									
									break;
								case GP2X_BUTTON_B:
									::cout<<"B Pressed"<<endl;
																received = true;
									temp = 'b';
									break;
								case GP2X_BUTTON_START:
									received = true;
									temp = 'q';
									goto_menu = true;
									
									break;
								case  GP2X_BUTTON_SELECT:
									::cout<<"Select Pressed - Write to log"<<endl;
									::cout.flush();
									break;
								case GP2X_BUTTON_VOLUP:
									::cout<<"VolUp pressed"<<endl;
									if ( music_volume < 120 ) {
										music_volume = music_volume + 10;
										Mix_VolumeMusic(music_volume);
									};
									break;
								case GP2X_BUTTON_VOLDOWN:
									::cout<<"VolDowj pressed"<<endl;
									if ( music_volume > 0 ) {
										music_volume = music_volume - 10;
										Mix_VolumeMusic(music_volume);
									};
									break;
							}
						break;
					};
				};
			};
		} else {
			::cout<<endl<<"What to do? chec(k), (f)old, (c)all, (b)et/raise?"<<endl;
			cin >> temp;
			::cout<<endl;
		};
		switch(temp)
		{
			case 'k':
				::cout<<"Check!!"<<endl;
				return "Check";
				break;
			case 'f':
				::cout<<"Fold!!"<<endl;
				return "Fold";
				break;
			case 'c':
				::cout<<"Call!!"<<endl;
				return "Call";
				break;
			case 'b':
				::cout<<"Bet!!"<<endl;
				return "Bet";
				break;
			case 'q':
				return "Quit";
				break;
			default:
				::cout<<"False Key!";
				return "Error!";
				break;
		};
	};
	
	
	// -----------------------------------------------
	// Adds a card to his hand and automatically sorts it for easier analyzing.
	void add_card(card new_card)
	{
		
		switch (cardcount)
		{
			case 0 : 
				cards[0] = new_card;
				eigen[0] = new_card;
				break;
			case 1 :
				if ( new_card.wert <= cards[0].wert ) { cards[1] = cards[0]; cards[0] = new_card;  } else { cards[1] = new_card; };
				eigen[1] = new_card;
				break;
			case 2 : {
				if ( new_card.wert <= cards[0].wert ) { 
					cards[2] = cards[1]; cards[1] = cards[0]; cards[0] = new_card; 
				} else if ( new_card.wert > cards[0].wert )
					if ( new_card.wert < cards[1].wert )
					{
						cards[2] = cards[1];
						cards[1] = new_card;
					} else {
						cards[2] = new_card;
					};
			};
				break;
			case 3 :
				if ( new_card.wert <= cards[0].wert ) { 
					cards[3] = cards[2];cards[2] = cards[1]; cards[1] = cards[0]; cards[0] = new_card; 
				} else if ( new_card.wert > cards[0].wert )
					if ( new_card.wert <= cards[1].wert )
					{
						cards[3] = cards[2];
						cards[2] = cards[1];
						cards[1] = new_card;
					} else {
						if ( new_card.wert <= cards[2].wert )
						{
							cards[3] = cards[2];
							cards[2] = new_card;
						} else {
							cards[3] = new_card;
						};
					};
				
				break;
			case 4 :
				if ( new_card.wert <= cards[0].wert ) { 
					cards[4] = cards[3];cards[3] = cards[2];cards[2] = cards[1]; cards[1] = cards[0]; cards[0] = new_card; 
				} else if ( new_card.wert > cards[0].wert )
					if ( new_card.wert <= cards[1].wert )
					{
						cards[4] = cards[3];
						cards[3] = cards[2];
						cards[2] = cards[1];
						cards[1] = new_card;
					} else {
						if ( new_card.wert <= cards[2].wert )
						{
							cards[4] = cards[3];
							cards[3] = cards[2];
							cards[2] = new_card;
						} else {
							if ( new_card.wert <= cards[3].wert )
							{	
								cards[4] = cards[3];
								cards[3] = new_card;
							} else {
								cards[4] = new_card;
							};
						};
					};
				
				break;
			case 5 :
				if ( new_card.wert <= cards[0].wert ) { 
					cards[5] = cards[4];cards[4] = cards[3];cards[3] = cards[2];cards[2] = cards[1]; cards[1] = cards[0]; cards[0] = new_card; 
				} else if ( new_card.wert > cards[0].wert )
					if ( new_card.wert <= cards[1].wert )
					{
						cards[5] = cards[4];
						cards[4] = cards[3];
						cards[3] = cards[2];
						cards[2] = cards[1];
						cards[1] = new_card;
					} else {
						if ( new_card.wert <= cards[2].wert )
						{
							cards[5] = cards[4];
							cards[4] = cards[3];
							cards[3] = cards[2];
							cards[2] = new_card;
						} else {
							if ( new_card.wert <= cards[3].wert )
							{	
								cards[5] = cards[4];
								cards[4] = cards[3];
								cards[3] = new_card;
							} else {
								if ( new_card.wert <= cards[4].wert )
								{	
									cards[5] = cards[4];
									cards[4] = new_card;
								} else {
									cards[5] = new_card;
								};
							};
						};
					};
				
				break;
			case 6 :
				if ( new_card.wert <= cards[0].wert ) { 
					cards[6] = cards[5];cards[5] = cards[4];cards[4] = cards[3];cards[3] = cards[2];cards[2] = cards[1]; cards[1] = cards[0]; cards[0] = new_card; 
				} else if ( new_card.wert > cards[0].wert )
					if ( new_card.wert <= cards[1].wert )
					{
						cards[6] = cards[5];
						cards[5] = cards[4];
						cards[4] = cards[3];
						cards[3] = cards[2];
						cards[2] = cards[1];
						cards[1] = new_card;
					} else {
						if ( new_card.wert <= cards[2].wert )
						{
							cards[6] = cards[5];
							cards[5] = cards[4];
							cards[4] = cards[3];
							cards[3] = cards[2];
							cards[2] = new_card;
						} else {
							if ( new_card.wert <= cards[3].wert )
							{	
								cards[6] = cards[5];
								cards[5] = cards[4];
								cards[4] = cards[3];
								cards[3] = new_card;
							} else {
								if ( new_card.wert <= cards[4].wert )
								{	
									cards[6] = cards[5];
									cards[5] = cards[4];
									cards[4] = new_card;
								} else {
									if ( new_card.wert <= cards[5].wert )
									{	
										cards[6] = cards[5];
										cards[5] = new_card;
									} else {
										cards[6] = new_card;
									};							
								};
							};
						};
					};
				
				break;
		};
		cardcount = cardcount + 1;
	};
	
};
//------------------------------------------------------------
// -----------------------------------------------
// PLAYER DECLERATION

player players[8];
	player added_players[8];
int pl_pointer[8];
void draw_action(player, string);


//------------------------------------------------------------
// -----------------------------------------------
// The money_pot class.

class money_pot
{
public:
	int money;
	int einsatz;
	
	
	// -----------------------------------------------
	// Will empty the pot and will reset all the variables.
	void empty()
	{
		bool b_small = false;
		bool b_big = false;
		money = 0;
		int temp = 0;
		einsatz = 0;
		while(temp<players_count) {
			if (btournament) {
				if ( players[temp].money > 0 ) {
					players[temp].last_action = "";
					players[temp].is_in = true;
					players[temp].einsatz = 0;
				};
			} else {
				players[temp].last_action = "";
				players[temp].is_in = true;
				players[temp].einsatz = 0;
			};
			temp = temp + 1;
		};
		
		if ( btournament ) {
		while(!b_small ) {
			payer_small = payer_small + 1;
			if ( payer_small == players_count ) {
				payer_small = 0;
			};
			if ( players[payer_small].money > 0 ) {
				b_small = true;
			};
		};
		
		while(!b_big ) {
			payer_big = payer_big + 1;
			if ( payer_big == players_count ) {
				payer_big = 0;
			};
			if ( players[payer_big].money > 0 ) {
				b_big = true;
			};
		};
		} else {
			payer_small = dealer + 1;
			if ( payer_small == players_count ) {
				payer_small = 0;
			};
			payer_big = payer_small + 1;
			if ( payer_big == players_count ) {
				payer_big = 0;
			};
		};
		

		money = small_blind + big_blind;
		players[payer_small].money = players[payer_small].money - small_blind;
		players[payer_big].money = players[payer_big].money - big_blind;
		players[payer_big].einsatz = big_blind;
		players[payer_small].einsatz = small_blind;
		einsatz = big_blind;
		
	};
		
	// -----------------------------------------------
	// One action the player can do with the pot. If someone already has raised, he can't check.
	int check(player &better)
	{
		if (better.has_betted == false && better.is_in == true) 
		{
			if (einsatz > better.einsatz ) {
				::cout<<"922 Redirect to Call";
				return call(better);
			} else {
				better.has_betted = true;
				better.last_action = "Check";
				return 1;
			};
		} else { return 0; };
	};
	
	// -----------------------------------------------
	// Another action to interact with the player. He will fold his cards and discard of the game.
	int fold(player &better)
	{
		
				better.is_in = false;
		better.has_betted = false;
		better.last_action = "Fold";
				return 1;
					
	};
	
	// -----------------------------------------------
	// Just a link. Calling this is easier than calling bet(player,int) if the player just wants to call.
	int call(player &better)
	{
		if (einsatz - better.einsatz == 0 ) {
			::cout<<"947 Redirect to Check";
			better.last_action = "Check";
		return check(better);
		} else {
			
		return bet(better,(einsatz - better.einsatz));
		};
	};
	
	// -----------------------------------------------
	// The main way to interact with the player. The player will give an amount of money in the pot.
	int bet(player &better, int bet_m)
	{
		if (better.is_in) 
		{
			
				int temp = 0;
					
					
					// Do the actual bet.
					better.has_betted = true;
					better.money = better.money - bet_m;
					better.einsatz = better.einsatz + bet_m;
					money = money + bet_m;
					
					if ( better.einsatz > einsatz ) // If he put in mroe money than the 'einsatz' was.
					{
						einsatz = better.einsatz;
						temp = 0;
						while ( temp < players_count ) // He has raised, so the other players have to do another turn.
						{
							players[temp].has_betted = false;
							if ( players[temp].last_action != "Fold" ) {
							players[temp].last_action = " ";
							};
							temp = temp + 1;
						};
						better.has_betted = true;
						
						
						better.last_action = "Raise";
							return 2; // return 2 means that we'll tell the play_round() function that it has to do another turn with the other players.
						
					};
					better.last_action = "Call";
					return 1;
		} else {
			return 0;
			
		};
		
	};
	
	
};

//----------------------------------------------------------------------
//----------------------------------------------------------------------
//   EVERYTHING WITH THE AI FOLLOWS HERE
//----------------------------------------------------------------------
//----------------------------------------------------------------------


class ai {
public:
	int riskyness;
	int starting_hands;
	bool take_best;
	
	string get_action(player pl, money_pot pot, int round, bool output = true) {
		if (output) {
		::cout<<pl.name<<" using ai "<<pl.use_ai<<endl<<"Riskyness: "<<riskyness<<" Starting Hands: "<<starting_hands<<" Take best: "<<take_best<<endl;
		::cout<<"Round: "<<round<<endl;
			};
		switch (round) {
			case 0: 
				::cout<<"Going to analyze_hole("<<pl.name<<", pot, "<<output<<endl;
				return analyze_hole(pl, pot, output);
				break;
			case 1:				::cout<<"Going to analyze_flop("<<pl.name<<", pot, "<<output<<endl;

				return analyze_flop(pl, pot, output);
				break;
			case 2:				::cout<<"Going to analyze_turn("<<pl.name<<", pot, "<<output<<endl;

				return analyze_turn( pl, pot, output);
				break;
			case 3:				
			::cout<<"Going to analyze_river("<<pl.name<<", pot, "<<output<<endl;

				return analyze_river(pl, pot, output);
				break;
			default:
				::cout<<"False Round, using algorythm analyze_river();"<<endl;
				return analyze_river(pl, pot, output);
		};
	};
	
	string analyze_hole(player player, money_pot pot, bool output = true) 
	{
		card c_1 = player.cards[0];
		card c_2 = player.cards[1];
		int chance_raise = 0;
		int chance_call = 100;
		int chance_fold = 0;
		int mitgehen_bis = 80;
		int group;
		int c_c_temp, c_f_temp;
		string hand;
		hand = cpp_to_int(c_2,c_1);
		if (output) ::cout<<"Analyzing hand..."<<hand<<"...";
		
		group = hand_to_group(hand);
		
		if ( output ) ::cout<<"finished. Give it a group...";
		switch (group) {
			case 0:
				chance_raise = 100;
				chance_call = 0;
				chance_fold = 0;
				mitgehen_bis = 100;
				break;
			case 1:
				chance_raise = 100;
				chance_call = 0;
				chance_fold = 0;
				mitgehen_bis = 100;
				break;
			case 2:
				chance_raise = 80;
				chance_call = 20;
				chance_fold = 0;
				mitgehen_bis = 100;
				
				break;
			case 3:
				chance_raise = 60;
				chance_call = 40;
				chance_fold = 0;
				mitgehen_bis = 100;
				
				break;
			case 4:
				chance_raise = 50;
				chance_call = 50;
				chance_fold = 0;
				mitgehen_bis = 100;
				
				break;
			case 5:
				if ( starting_hands > 0 ) {
					chance_raise = 15;
					chance_call = 60;
					chance_fold = 25;
					mitgehen_bis = 70;
				} else {
					chance_fold = 75;
					chance_raise = 0;
					chance_call = 25;
					mitgehen_bis = 60;
				};
				break;
			case 6:
				
				if ( starting_hands > 1 ) {
					chance_raise = 0;
					chance_call = 50;
					chance_fold = 50;
					mitgehen_bis = 40;
				} else {
					chance_fold = 100;
					chance_raise = 0;
					chance_call = 0;
					mitgehen_bis = 20;
				};
				break;
			case 7:
				
				if ( starting_hands > 2 ) {
					chance_raise = 0;
					chance_call = 50;
					chance_fold = 50;
					mitgehen_bis = 30;
				} else {
					chance_fold = 100;
					chance_raise = 0;
					chance_call = 0;
					mitgehen_bis = 10;
				};
				
				break;
			case 8:
					chance_fold = 100;
					chance_raise = 0;
				chance_call = 0;
				mitgehen_bis = 0;
				
				break;
		};
		if ( output ) {
		::cout<<"..finished"<<endl<<endl;
		::cout<<"Cards: "<<hand<<endl;
		::cout<<"Group: "<<group<<" with chances:   Raise "<<chance_raise<<" | Call "<<chance_call<<" | Fold "<<chance_fold<<endl;
		};
		
		int temp = 0;
		int other_players = 0;
		while ( temp < players_count ) {
			if ( players[temp].is_in ) {
				other_players = other_players + 1;
			};
			temp = temp + 1;
		};
		if (other_players < 2 ) {
				if ( output ) ::cout<<endl<<endl<<endl<<endl<<"-----CALLED BECAUSE NO ONE'S LEFT----"<<endl<<endl<<endl;
				return "Call";
			
		}; 
		
		if ( other_players < 4 ) {
			temp = (int)((double)rand()*10/RAND_MAX);
			if ( temp < 5 ) {
				return "Call";
			};
		};
		
		if ( pot.einsatz - player.einsatz == 0 ) {
			
					chance_call = chance_call + chance_fold;
					chance_fold = 0;
			
		};
	
	
				

			
		
		if ( riskyness != 0 && chance_fold < 100 ) {
		mitgehen_bis = mitgehen_bis + riskyness * 3;
		};
		
		if ( output ) {
		::cout<<"Pot.einsatz = "<<pot.einsatz<<" | Mitgehen_bis = "<<mitgehen_bis<<"  ";
		};
		
		if (pot.einsatz > mitgehen_bis ) {
		chance_raise = 0;
		chance_call = 0;
		chance_fold = 100;
		if ( output ) {
		::cout<<"Too high risk - Out of here.";
		};
		};
		::cout<<endl;
		
		if (pot.einsatz / 1.5 < mitgehen_bis ) {
		if ( riskyness != 0 && chance_fold < 100 ) {
			chance_raise = chance_raise - 25 + riskyness * 2 ;
			chance_call = chance_call + 25 - riskyness * 2;
		};
		};
		
		if (pot.einsatz - player.einsatz == 0 && chance_fold < 90 ) {
		if ( output ) {
			::cout<<"No Bet in - Raises chances for call and bet."<<endl;
		};
			if (riskyness > -1 ) {
				chance_call = chance_fold / 2 + chance_call;
				chance_fold = chance_fold / 2;
			};
			if ( chance_call > 25 ) {
				if (chance_raise > 0 ) {
					chance_call = chance_call - 25;
					chance_raise = chance_raise + 25;
				} else {
					chance_call = chance_call + 25;
					chance_fold = chance_fold - 25;
				};
			} else {
				if ( chance_raise > 0 ) {
					chance_raise = chance_raise + chance_call;
					chance_call = 0;
				} else {
					chance_fold = 0;
					chance_call = 100;
				};

			};
		};
			
		
		if (chance_raise < 0 ) {
			chance_raise = 0;
		} else if (chance_raise > 100 ) {
			chance_call = 0;
			chance_fold = 0;
			chance_raise = 100;
		};
		if (chance_fold < 0 ) {
			chance_fold = 0;
		} else if (chance_fold > 100 ) {
			chance_call = 0;
			chance_raise = 0;
			chance_fold = 100;
		};
		if (chance_call < 0 ) {
			chance_call = 0;
		} else if (chance_call > 100 ) {
			chance_fold = 0;
			chance_raise = 0;
			chance_call = 100;
		};
		if ( output ) {
		::cout<<"New chances after correcting <0 / >100:  Raise "<<chance_raise<<" | Call "<<chance_call<<" | Fold "<<chance_fold<<endl;
		};
			
		
		if (riskyness != 0 && chance_fold < 100 && chance_fold > 0) {
		if ( output ) {
			::cout<<" Old Chances ( c,r,f ) : "<<chance_call<<" "<<chance_raise<<" "<<chance_fold<<" "<<endl;
		};
				chance_call = chance_call + 2 * riskyness;
				chance_raise = chance_raise + 1 * riskyness;
				chance_fold = chance_fold - 3 * riskyness;
		};
			
		
		if (chance_raise < 0 ) {
			chance_raise = 0;
		} else if (chance_raise > 100 ) {
			chance_call = 0;
			chance_fold = 0;
			chance_raise = 100;
		};
		if (chance_fold < 0 ) {
			chance_fold = 0;
		} else if (chance_fold > 100 ) {
			chance_call = 0;
			chance_raise = 0;
			chance_fold = 100;
		};
		if (chance_call < 0 ) {
			chance_call = 0;
		} else if (chance_call > 100 ) {
			chance_fold = 0;
			chance_raise = 0;
			chance_call = 100;
		};
		if ( output ) {
		::cout<<"Definite Chances ( c,r,f ) : "<<chance_call<<" "<<chance_raise<<" "<<chance_fold<<" "<<endl;
		};
		
		if ( take_best ) {
			if ( chance_call > chance_raise and chance_call > chance_fold ) {
				return "Call";
			} else if ( chance_raise > chance_call and chance_raise > chance_fold ) {
				return "Bet";
			} else if ( chance_fold > chance_call and chance_fold > chance_raise ) {
				return "Fold";
			}
		};
		
		c_c_temp = chance_call + chance_raise;
		c_f_temp = chance_fold + c_c_temp;
		
		temp = (int)((double)rand()*100/RAND_MAX); 
		
		if ( temp < chance_raise ) {
				
					return "Bet";
				
					
		} else if (temp < c_c_temp ) {
			
			return "Call";
		} else if (temp < c_f_temp ) {
			
			return "Fold";
		} else {
			return "EROOR";
		};
			
				
	};
	
	//ANALYZE AFTER FLOP
	
	string analyze_flop(player player, money_pot pot, bool output = true) {
		::cout<<"Reached analyze one"<<endl;
		int handart;
		::cout<<"Initialyzed type variable"<<endl;
		int chance_raise = 0;
		int chance_call = 50;
		int chance_fold = 50;
		::cout<<"Initialyzed variables for checking and folding."<<endl;
		int c_c_temp = 0;
		int c_f_temp = 0;
		::cout<<"Initialyzed variables for c_c_temp and c_f_temp."<<endl;
		
		handart = get_points(player.cards,true,5,true);
		::cout<<".got points. Sort them to type..";
		switch (handart) {
			case 0:
				if ( player.cards[4].wert >= 9 && player.cards[3].wert >= 8 && player.cards[2].wert >= 8 && player.cards[1].wert >= 6 ) {
					chance_call = 15 + player.cards[4].wert * 2 + player.cards[1].wert;
					chance_fold = 85 - player.cards[4].wert * 2 - player.cards[1].wert;
				} else {
					chance_call = 0;
					chance_fold = 100;
				}
				chance_raise = 0;
			
				break;
			case 1:
			
				chance_raise = 0;
				if (player.cards[3].wert == player.cards[4].wert) {
					chance_call = 70;
					chance_fold = 30;
				} else if (player.cards[2].wert == player.cards[3].wert) {
					chance_call = 60 + player.cards[3].wert * 2;
					chance_fold = 40 - player.cards[3].wert * 2;
				} else {
					chance_call = 55;
					chance_fold = 45;
				};
			
				break;
			case 2:
				chance_raise = 70 ;
				chance_call = 30 ;
				chance_fold = 0;
				break;
			case 3:
				chance_raise = 80;
				chance_call = 20;
				chance_fold = 0;
				break;
			case 4:
				if (player.eigen[0].sorte == player.eigen[1].sorte ) {
					chance_raise = 90;
					chance_call = 10;
					chance_fold = 0;
				} else {
					chance_raise = 30;
					chance_call = 60;
					chance_fold = 10;
				};
				break;
			case 5:
				chance_raise = 100;
				chance_call = 0;
				chance_fold = 0;
				break;
			case 6:
				chance_raise = 100;
				chance_call = 0;
				chance_fold = 0;
				break;
			case 7:
				chance_raise = 100;
				chance_call = 0;
				chance_fold = 0;
				
				break;
			case 8:
				chance_raise = 100;
				chance_call = 0;
				chance_fold = 0;
				
				break;		
		};
		if ( output ) ::cout<<"..finished  "<<handart<<endl<<endl;
		
		int temp = 0;
		int other_players = 0;
		while ( temp < players_count ) {
			if ( players[temp].is_in ) {
				other_players = other_players + 1;
			};
			temp = temp + 1;
		};
				
		if (other_players < 2 ) {
			if ( output ) ::cout<<endl<<endl<<endl<<endl<<"-----CALLED BECAUSE NO ONE'S LEFT----"<<endl<<endl<<endl;
			return "Call";
					
		}; 
		
		if ( other_players < 4 ) {
			temp = (int)((double)rand()*10/RAND_MAX);
			if ( temp < 5 ) {
				return "Call";
			};
		};
			
		
		if ( pot.einsatz - player.einsatz == 0 ) {
			
			chance_call = chance_call + chance_fold;
			chance_fold = 0;
					
		};
				
		
		
		
		if (chance_fold == 100 ) {
			return "Fold";
		};
		
		
		
				
		if ( riskyness != 0 && chance_fold < 100 ) {
			if (output) ::cout<<"Chances before risky (f,c,r): "<<chance_fold<<" "<<chance_call<<" "<<chance_raise<<endl;
			
			chance_call = chance_call + 2 * riskyness;
			chance_raise = chance_raise + 1 * riskyness;
			chance_fold = chance_fold - 3 * riskyness;
		};
		
		if (output) {
			::cout<<"Type: "<<handart;
			::cout<<"Chances:  Fold "<<chance_fold<<" | Call/Check: "<<chance_call<<" | Raise: "<<chance_raise<<endl<<endl;
		};
		
		
		
		if ( take_best ) {
			if ( chance_call > chance_raise and chance_call > chance_fold ) {
				return "Call";
			} else if ( chance_raise > chance_call and chance_raise > chance_fold ) {
				return "Bet";
			} else if ( chance_fold > chance_call and chance_fold > chance_raise ) {
				return "Fold";
			}
		};
		
		c_c_temp = chance_call + chance_raise;
		c_f_temp = chance_fold + c_c_temp;
		
		temp = (int)((double)rand()*100/RAND_MAX); 
		if ( temp < chance_raise ) {
			
			return "Bet";
			
			
		} else if (temp < c_c_temp ) {
			
			return "Call";
		} else if (temp < c_f_temp ) {
			
			return "Fold";
		} else {
			return "EROOR";
		};		
		
	
	};
	
	string analyze_turn(player player, money_pot pot, bool output = true) {
		int handart;
		int chance_raise= 0;
		int chance_call = 100;
		int chance_fold = 0;
		int c_c_temp, c_f_temp;
		
		if ( output ) ::cout<<"Getting points...";
		handart = get_points(player.cards,true,6,true);
		if ( output ) ::cout<<".got points. Sort them to type..";
		
		switch (handart) {
			case 0:
					chance_call = 0;
					chance_fold = 100;
				chance_raise = 0;
				
				break;
			case 1:
				
				chance_raise = 0;
					chance_call = 55;
					chance_fold = 45;
				
				
				break;
			case 2:
				chance_raise = 60 ;
				chance_call = 40 ;
				chance_fold = 0;
				break;
			case 3:
				chance_raise = 70;
				chance_call = 30;
				chance_fold = 0;
				break;
			case 4:
				if (player.eigen[0].sorte == player.eigen[1].sorte ) {
					chance_raise = 90;
					chance_call = 10;
					chance_fold = 0;
				} else {
					chance_raise = 30;
					chance_call = 60;
					chance_fold = 10;
				};
				break;
			case 5:
				chance_raise = 100;
				chance_call = 0;
				chance_fold = 0;
				break;
			case 6:
				chance_raise = 100;
				chance_call = 0;
				chance_fold = 0;
				break;
			case 7:
				chance_raise = 100;
				chance_call = 0;
				chance_fold = 0;
				
				break;
			case 8:
				chance_raise = 100;
				chance_call = 0;
				chance_fold = 0;
				
				break;		
		};
		if ( output ) ::cout<<"finished."<<endl<<endl;
		
		int temp = 0;
		int other_players = 0;
		while ( temp < players_count ) {
			if ( players[temp].is_in ) {
				other_players = other_players + 1;
			};
			temp = temp + 1;
		};
		if (other_players < 2 ) {
			::cout<<endl<<endl<<endl<<endl<<"-----CALLED BECAUSE NO ONE'S LEFT----"<<endl<<endl<<endl;
			
			if ( chance_fold > 0 ) {
				return "Call";
			};
			
		} else if (other_players < 4 ) {
			if ( chance_fold < 100 ) {
				chance_fold = chance_fold - 15;
				chance_call = chance_call + 15;
			};
		};
		
		if (pot.einsatz - player.einsatz == 0  ) {
			chance_call = chance_call + chance_fold;
			chance_fold = 0;
		};
		
		
		
		
		
		
		if ( riskyness != 0 && chance_fold < 100 ) {
			if (output) ::cout<<"Chances before risky (f,c,r): "<<chance_fold<<" "<<chance_call<<" "<<chance_raise<<endl;
			chance_call = chance_call + 2 * riskyness;
			chance_raise = chance_raise + 1 * riskyness;
			chance_fold = chance_fold - 3 * riskyness;
		};
		
		if (output) {
			::cout<<"handart: "<<handart;
			::cout<<"Chances:  Fold "<<chance_fold<<" | Call/Check: "<<chance_call<<" | Raise: "<<chance_raise<<endl<<endl;
		};
		
		
		
		if (chance_raise < 0 ) {
			chance_raise = 0;
		} else if (chance_raise > 100 ) {
			chance_call = 0;
			chance_fold = 0;
			chance_raise = 100;
		};
		if (chance_fold < 0 ) {
			chance_fold = 0;
		} else if (chance_fold > 100 ) {
			chance_call = 0;
			chance_raise = 0;
			chance_fold = 100;
		};
		if (chance_call < 0 ) {
			chance_call = 0;
		} else if (chance_call > 100 ) {
			chance_fold = 0;
			chance_raise = 0;
			chance_call = 100;
		};
		
		if ( take_best ) {
			if ( chance_call > chance_raise and chance_call > chance_fold ) {
				return "Call";
			} else if ( chance_raise > chance_call and chance_raise > chance_fold ) {
				return "Bet";
			} else if ( chance_fold > chance_call and chance_fold > chance_raise ) {
				return "Fold";
			}
		};
		
		c_c_temp = chance_call + chance_raise;
		c_f_temp = chance_fold + c_c_temp;
		
		
		temp = (int)((double)rand()*100/RAND_MAX); 
		if ( temp < chance_raise ) {
		
			return "Bet";
			
			
		} else if (temp < c_c_temp ) {
			
			return "Call";
		} else if (temp < c_f_temp ) {
			
			return "Fold";
		} else {
			return "EROOR";
		};		
		
		
		
	};
	
	string analyze_river(player player, money_pot pot, bool output = true) {
		int handart;
		int chance_raise= 0;
		int chance_call = 100;
		int chance_fold = 0;
		int c_c_temp, c_f_temp;
		
		
		if ( output ) ::cout<<"Getting points...";
		handart = get_points(player.cards,true,7,true);
		if ( output ) ::cout<<".got points. Sort them to handart..";
		
		switch (handart) {
			case 0:
				if ( player.cards[4].wert >= 9 && player.cards[3].wert >= 8 && player.cards[2].wert >= 8 && player.cards[1].wert >= 6 ) {
					chance_call = 15 + player.cards[4].wert * 2 + player.cards[1].wert;
					chance_fold = 85 - player.cards[4].wert * 2 - player.cards[1].wert;
				} else {
					chance_call = 0;
					chance_fold = 100;
				}
				chance_raise = 0;
				
				break;
			case 1:
				
				chance_raise = 0;
				if (player.cards[3].wert == player.cards[4].wert) {
					chance_call = 70;
					chance_fold = 30;
				} else if (player.cards[2].wert == player.cards[3].wert) {
					chance_call = 60 + player.cards[3].wert * 2;
					chance_fold = 40 - player.cards[3].wert * 2;
				} else {
					chance_call = 55;
					chance_fold = 45;
				};
				
				break;
			case 2:
				chance_raise = 60 ;
				chance_call = 40 ;
				chance_fold = 0;
				break;
			case 3:
				chance_raise = 70;
				chance_call = 30;
				chance_fold = 0;
				break;
			case 4:
				if (player.eigen[0].sorte == player.eigen[1].sorte ) {
					chance_raise = 100;
					chance_call = 0;
					chance_fold = 0;
				} else {
					chance_raise = 30;
					chance_call = 60;
					chance_fold = 10;
				};
				break;
			case 5:
				chance_raise = 100;
				chance_call = 0;
				chance_fold = 0;
				break;
			case 6:
				chance_raise = 100;
				chance_call = 0;
				chance_fold = 0;
				break;
			case 7:
				chance_raise = 100;
				chance_call = 0;
				chance_fold = 0;
				
				break;
			case 8:
				chance_raise = 100;
				chance_call = 0;
				chance_fold = 0;
				
				break;		
		};
		if ( output ) ::cout<<"finished"<<endl<<endl;
		
		int temp = 0;
		int other_players = 0;
		while ( temp < players_count ) {
			if ( players[temp].is_in ) {
				other_players = other_players + 1;
			};
			temp = temp + 1;
		};
		if (other_players < 2 ) {
			if ( output ) ::cout<<endl<<endl<<endl<<endl<<"-----CALLED BECAUSE NO ONE'S LEFT----"<<endl<<endl<<endl;
			
			if ( chance_fold > 0 ) {
				return "Call";
			};
			
		} else if (other_players < 4 ) {
			if ( chance_fold < 100 ) {
				chance_fold = chance_fold - 15;
				chance_call = chance_call + 15;
			};
		};
		if (pot.einsatz - player.einsatz == 0 ) {
			if ( output ) {
				::cout<<"No Bet in - Raises chances for call and bet."<<endl;
			};
			
				chance_call = chance_call + chance_fold;
				chance_fold = 0;
		};
		
		
		
		
		
		
		if ( riskyness != 0 && chance_fold < 100 ) {
			
			if (output) ::cout<<"Chances before risky (f,c,r): "<<chance_fold<<" "<<chance_call<<" "<<chance_raise<<endl;
			chance_call = chance_call + 2 * riskyness;
			chance_raise = chance_raise + 1 * riskyness;
			chance_fold = chance_fold - 3 * riskyness;
		};
		
		if (output) {
			::cout<<"handart: "<<handart;
			::cout<<"Chances:  Fold "<<chance_fold<<" | Call/Check: "<<chance_call<<" | Raise: "<<chance_raise<<endl<<endl;
		};
		
		
		if (chance_raise < 0 ) {
			chance_raise = 0;
		} else if (chance_raise > 100 ) {
			chance_call = 0;
			chance_fold = 0;
			chance_raise = 100;
		};
		if (chance_fold < 0 ) {
			chance_fold = 0;
		} else if (chance_fold > 100 ) {
			chance_call = 0;
			chance_raise = 0;
			chance_fold = 100;
		};
		if (chance_call < 0 ) {
			chance_call = 0;
		} else if (chance_call > 100 ) {
			chance_fold = 0;
			chance_raise = 0;
			chance_call = 100;
		};
		c_c_temp = chance_call + chance_raise;
		c_f_temp = chance_fold + c_c_temp;
		
		if ( take_best ) {
			if ( chance_call > chance_raise and chance_call > chance_fold ) {
				return "Call";
			} else if ( chance_raise > chance_call and chance_raise > chance_fold ) {
				return "Bet";
			} else if ( chance_fold > chance_call and chance_fold > chance_raise ) {
				return "Fold";
			}
		};
		
		temp = (int)((double)rand()*100/RAND_MAX); 
		if ( temp < chance_raise ) {
						return "Bet";
			
			
		} else if (temp < c_c_temp ) {
			
			return "Call";
		} else if (temp < c_f_temp ) {
			
			return "Fold";
		} else {
			return "EROOR";
		};		
		
		
		
	};
	
	string cpp_to_int(card c_1, card c_2, bool output = false) {
		if ( output ) ::cout<<"cpp_to_int...";
		string temp1 = "";
	
		switch(c_1.wert) {
			case 0: temp1 = temp1 + "2"; break;
			case 1: temp1 = temp1 + "3"; break;
			case 2: temp1 = temp1 + "4"; break;
			case 3: temp1 = temp1 + "5"; break;
			case 4: temp1 = temp1 + "6"; break;
			case 5: temp1 = temp1 + "7"; break;
			case 6: temp1 = temp1 + "8"; break;
			case 7: temp1 = temp1 + "9"; break;
			case 8: temp1 = temp1 + "T"; break;
			case 9: temp1 = temp1 + "J"; break;
			case 10: temp1 = temp1 + "Q"; break;
			case 11: temp1 = temp1 + "K"; break;
			case 12: temp1 = temp1 + "A"; break;
		};
		switch(c_2.wert) {
			case 0: temp1 = temp1 + "2"; break;
			case 1: temp1 = temp1 + "3"; break;
			case 2: temp1 = temp1 + "4"; break;
			case 3: temp1 = temp1 + "5"; break;
			case 4: temp1 = temp1 + "6"; break;
			case 5: temp1 = temp1 + "7"; break;
			case 6: temp1 = temp1 + "8"; break;
			case 7: temp1 = temp1 + "9"; break;
			case 8: temp1 = temp1 + "T"; break;
			case 9: temp1 = temp1 + "J"; break;
			case 10: temp1 = temp1 + "Q"; break;
			case 11: temp1 = temp1 + "K"; break;
			case 12: temp1 = temp1 + "A"; break;
		};
		if ( output ) ::cout<<"finished"<<endl<<endl;
		return temp1;
	};
	
int hand_to_group(string hand) {
	int group;
	switch (hand[0]) {
			case 'A':
				switch (hand[1]) {
					case 'A':
						group = 0;
						break;
					case 'K':
						if (hand[1] == hand[0]) {
							group = 1;
						} else {
							group = 2;
						};
						break;
						
					case 'Q':
						if (hand[1] == hand[0]) {
							group = 2;
						} else {
							group = 3;
						};
				
						break;
				
					case 'J':
						if (hand[1] == hand[0]) {
							group = 2;
						} else {
							group = 4;
						};
						break;
				
					case 'T':
						if (hand[1] == hand[0]) {
							group = 3;
						} else {
							group = 4;
						};
						break;
				
					default:
						if (hand[1] == hand[0]) {
							group = 4;
						} else {
							group = 7;
						};
					break;
				};
				break;
			case 'K':
				switch (hand[1]) {
					
					case 'K':
							group = 1;
						break;
						
					case 'Q':
						if (hand[1] == hand[0]) {
							group = 2;
						} else {
							group = 4;
						};
						
						break;
						
					case 'J':
						if (hand[1] == hand[0]) {
							group = 3;
						} else {
							group = 5;
						};
						break;
						
					case 'T':
						if (hand[1] == hand[0]) {
							group = 3;
						} else {
							group = 5;
						};
						break;
						
					default:
						if (hand[1] == hand[0]) {
							group = 6;
						} else {
							group = 8;
						};
						break;
				};
				break;
				
			case 'Q':
				switch (hand[1]) {
					case 'Q':
							group = 1;
						break;
						
					case 'J':
						if (hand[1] == hand[0]) {
							group = 3;
						} else {
							group = 5;
						};
						break;
						
					case 'T':
						if (hand[1] == hand[0]) {
							group = 4;
						} else {
							group = 5;
						};
						break;
						
					case '9':
						if (hand[1] == hand[0]) {
							group = 5;
						} else {
							group = 7;
						};
						break;	
					
					default:
						if (hand[1] == hand[0]) {
							group = 7;
						} else {
							group = 8;
						};
						break;
				};
				break;
				
			case 'J':
				switch (hand[1]) {
					
					case 'J':
						group = 1;
						break;
						
					case 'T':
						if (hand[1] == hand[0]) {
							group = 4;
						} else {
							group = 5;
						};
						break;
						
					case '9':
						if (hand[1] == hand[0]) {
							group = 5;
						} else {
							group = 6;
						};
						break;	
						
					default:
						if (hand[1] == hand[0]) {
							group = 7;
						} else {
							group = 8;
						};
						break;
				};
				break;
				
			case 'T':
				switch (hand[1]) {
					
					case 'T':
						group = 2;
						break;
						
					case '9':
						if (hand[1] == hand[0]) {
							group = 5;
						} else {
							group = 6;
						};
						break;	
						
					case '8':
						if (hand[1] == hand[0]) {
							group = 6;
						} else {
							group = 7;
						};
						break;	
					default:
						if (hand[1] == hand[0]) {
							group = 7;
						} else {
							group = 8;
						};
						break;
				};
				break;
				
			case '9':
				switch (hand[1]) {
					
					case '9':
							group = 3;
						break;
						
					case '8':
						if (hand[1] == hand[0]) {
							group = 6;
						} else {
							group = 6;
						};
						break;
					
					default:
						if (hand[1] == hand[0]) {
							group = 7;
						} else {
							group = 8;
						};
						break;
				};
				break;
				
			default:
				if (hand[0] == hand[1]) {
					group = 5;
				} else if (hand[1] == hand[0]) {
					group = 6;
				} else {
					group = 7;
				};
				
				break;
			};
		return group;
};
};





ai ai_list[12];

void generate_players() {
	int temp;
	int used_names[7];
	players[0].name = players_name;
	
	ai_names[0] = "Bill";
	ai_names[1] = "Linus";
	ai_names[2] = "Angela";
	ai_names[3] = "Steve";
	ai_names[4] = "Doyle";
	ai_names[5] = "Johnny";
	ai_names[6] = "Chris";
	ai_names[7] = "Paul";
	ai_names[8] = "Greg";
	ai_names[9] = "Annie";
	ai_names[10] = "Phil";
	ai_names[11] = "Abbie";
	ai_names[12] = "Mike";
	ai_names[13] = "Hoyt";
	ai_names[14] = "Tony";
	ai_names[15] = "Grant";
	ai_names[16] = "David";
	ai_names[17] = "Keith";
	ai_names[18] = "DaveN";
	ai_names[19] = "Alton";
	ai_names[20] = "Sarah";
	ai_names[21] = "Sailor";
	ai_names[22] = "Puggy";
	ai_names[23] = "Brady";
	ai_names[24] = "Buddy";
	ai_names[25] = "Luca";
	ai_names[26] = "Adam";
	ai_names[27] = "Eva";
	ai_names[28] = "Pham";
	ai_names[29] = "Yo-Yo";
	ai_names[30] = "Noah";
	ai_names[31] = "LeGrand";
	ai_names[32] = "Mats";
	ai_names[33] = "Perry";
	ai_names[34] = "Holly";
	ai_names[35] = "Rocky";
	ai_names[36] = "Jeff";
	ai_names[37] = "Max M";
	ai_names[38] = "Steve";
	ai_names[39] = "Rylan";
	ai_names[40] = "Ringo";
	ai_names[41] = "Tyler";
	ai_names[42] = "Barmy";
	
	bool usable = false;
	
	temp = (int)((double)rand()*42/RAND_MAX);
	used_names[0] = temp;
	players[1].name = ai_names[temp];
	
	
	while (!usable) {
		temp = (int)((double)rand()*42/RAND_MAX);
		if ( temp != used_names[0] ) {
			used_names[1] = temp;
			usable = true;
		};
	};
	players[2].name = ai_names[temp];	
	usable = false;
	
	while (!usable) {
		temp = (int)((double)rand()*42/RAND_MAX);
		if ( temp != used_names[0] && temp != used_names[1] ) {
			used_names[2] = temp;
			usable = true;
		};
	};
	players[3].name = ai_names[temp];
	usable = false;
	
	
	while (!usable) {
		temp = (int)((double)rand()*42/RAND_MAX);
		if ( temp != used_names[0] && temp != used_names[1] && temp != used_names[2] ) {
			used_names[3] = temp;
			usable = true;
		};
	};
	players[4].name = ai_names[temp];
	usable = false;
	
	
	
	while (!usable) {
		temp = (int)((double)rand()*42/RAND_MAX);
		if ( temp != used_names[0] && temp != used_names[1] && temp != used_names[2] && temp != used_names[3] ) {
			used_names[4] = temp;
			usable = true;
		};
	};
	players[5].name = ai_names[temp];
	usable = false;
	
	
	while (!usable) {
		temp = (int)((double)rand()*42/RAND_MAX);
		if ( temp != used_names[0] && temp != used_names[1] && temp != used_names[2] && temp != used_names[3] && temp != used_names[4] ) {
			used_names[5] = temp;
			usable = true;
		};
	};
	players[6].name = ai_names[temp];
	usable = false;
	
	
	
	while (!usable) {
		temp = (int)((double)rand()*42/RAND_MAX);
		if ( temp != used_names[0] && temp != used_names[1] && temp != used_names[2] && temp != used_names[3] && temp != used_names[4] && temp != used_names[5] ) {
			used_names[6] = temp;
			usable = true;
		};
	};
	players[7].name = ai_names[temp];
	usable = false;
	
	
	players[0].is_ai = false;
	players[1].is_ai = true;
	players[2].is_ai = true;
	players[3].is_ai = true;
	players[4].is_ai = true;
	players[5].is_ai = true;
	players[6].is_ai = true;
	players[7].is_ai = true;
	players[0].use_ai = (int)((double)rand()*11/RAND_MAX); 
	players[1].use_ai = (int)((double)rand()*11/RAND_MAX); 
	players[2].use_ai = (int)((double)rand()*11/RAND_MAX); 
	players[3].use_ai = (int)((double)rand()*11/RAND_MAX); 
	players[4].use_ai = (int)((double)rand()*11/RAND_MAX); 
	players[5].use_ai = (int)((double)rand()*11/RAND_MAX);
	players[6].use_ai = (int)((double)rand()*11/RAND_MAX); 
	players[7].use_ai = (int)((double)rand()*11/RAND_MAX);
	players[0].money = start_money;
	players[1].money = start_money;
	players[2].money = start_money;
	players[3].money = start_money;
	players[4].money = start_money;
	players[5].money = start_money;
	players[6].money = start_money;
	players[7].money = start_money;
	
	//WORKS - Bad
	ai_list[0].riskyness = 2;
	ai_list[0].starting_hands = 3;
	ai_list[0].take_best = true;
	
	ai_list[1].riskyness = -5;
	ai_list[1].starting_hands = 2;
	ai_list[1].take_best = true;
	
	//WORKS - FANTASTIC
	ai_list[2].riskyness = 7;
	ai_list[2].starting_hands = 3;
	ai_list[2].take_best = true;
	
	ai_list[3].riskyness = 0;
	ai_list[3].starting_hands = 2;
	ai_list[3].take_best = true;
	
	ai_list[4].riskyness = 6;
	ai_list[4].starting_hands = 1;
	ai_list[4].take_best = true;
	
	//WORKS
	ai_list[5].riskyness = -5;
	ai_list[5].starting_hands = 3;
	ai_list[5].take_best = true;
	
	//WORKS 
	ai_list[6].riskyness = 10;
	ai_list[6].starting_hands = 3;
	ai_list[6].take_best = false;
	
	//WORKS - So La La
	ai_list[7].riskyness = 4;
	ai_list[7].starting_hands = 2;
	ai_list[7].take_best = true;
	
	
	//WORKS - Good
	ai_list[8].riskyness = 7;
	ai_list[8].starting_hands = 2;
	ai_list[8].take_best = true;
	
	ai_list[9].riskyness = 8;
	ai_list[9].starting_hands = 3;
	ai_list[9].take_best = false;
	
	//WORKS - Fantastic!
	ai_list[10].riskyness = 0;
	ai_list[10].starting_hands = 2;
	ai_list[10].take_best = false;
	
	ai_list[11].riskyness = 6;
	ai_list[11].starting_hands = 2;
	ai_list[11].take_best = true;
	
	pl_pointer[0] = 0;
	pl_pointer[1] = 1;
	pl_pointer[2] = 2;
	pl_pointer[3] = 3;
	pl_pointer[4] = 4;
	pl_pointer[5] = 5;
	pl_pointer[6] = 6;
	pl_pointer[7] = 7;
	
	if (btournament) {
	
		players[3].name = "DaveN";
		
		players[1].name = "Linus";
		players[1].use_ai = 10;
		
		players[2].name = "Jesus";
		
		players[7].name = "Stevo";
		players[7].use_ai = 2;
		
		players[5].name = "Pham";
		players[5].use_ai = 3;
		
		players[4].name = "C4";
		
		players[6].name = "Tex";
		players[6].use_ai = 5;
	};
	
};
	



//----------------------------------------------------------------------
//----------------------------------------------------------------------
//   FUNCTIONS THAT WILL BE USED IN GAMEPLAY THINGS ARE FOLLOWING HERE
//----------------------------------------------------------------------
//----------------------------------------------------------------------

// -----------------------------------------------
//
// Function that gets the action of the player and then executes it.

int turn(player &turner, money_pot &pot,int round, TTF_Font *font = NULL, TTF_Font *font_bigger = NULL, bool output = true)
{
	if (round == 4 ) {
		::cout<<"CRITICAL ERROR: ROUND = 4"<<endl;
	return 1;
	};
	string temp_a;
	::cout<<"turner.name: "<<turner.name<<" Is AI: "<<turner.is_ai<<" Round: "<<round<<endl;
	if ( turner.is_ai ) {
		temp_a = ai_list[turner.use_ai].get_action(turner, pot, round,output);
		if ( output ) {
		};
	} else {
		temp_a = turner.get_action(font, font_bigger);
	};
		::cout<< temp_a<<endl<<endl;
	if (temp_a == "Bet")
	{
		int temp_b;
		if ( round < 2 ) {
			if ( pot.einsatz < 4 * low_limit ) {
			temp_b = low_limit + pot.einsatz - turner.einsatz;
				return pot.bet(turner,temp_b);
			} else {
			return pot.call(turner);
			};
		} else {
			if ( pot.einsatz < 4 * high_limit ) {
				temp_b = high_limit + pot.einsatz - turner.einsatz;
				return pot.bet(turner,temp_b);
			} else {
				return pot.call(turner);
			};
		};
	} else if ( temp_a == "Fold" ) 
	{
		return pot.fold(turner);
	} else if (temp_a == "Call")
	{
		if ( pot.einsatz - turner.einsatz > 0 ) {
			return pot.call(turner);
		} else {
			return pot.check(turner);
		};
	} else if (temp_a == "Check")
	{
		return pot.check(turner);
	} else if (temp_a == "Quit")
	{
		return 3;
	} else {
	return pot.call(turner);
	};
};

// -----------------------------------------------
//
// Function that gives the cards to the player. Second argument will be: 0 = Private, 1 = Flop, 2 = Next phase, 3 = Last one ( Something with river )

void give_cards(card deck[52], int phase)
{

	int temp = 0;
	switch (phase)
	{
		case 0:	
			draw_graphics("Hole Cards",0);
			draw_graphics("Enemy Cards",0);
			players[0].add_card(deck[30]);
			players[0].add_card(deck[1]);
			players[1].add_card(deck[2]);
			players[1].add_card(deck[3]);			
			players[2].add_card(deck[4]);
			players[2].add_card(deck[5]);			
			players[3].add_card(deck[6]);
			players[3].add_card(deck[7]);			
			players[4].add_card(deck[8]);
			players[4].add_card(deck[9]);	
			players[5].add_card(deck[20]);
			players[5].add_card(deck[21]);
			players[6].add_card(deck[22]);
			players[6].add_card(deck[23]);			
			players[7].add_card(deck[24]);
			players[7].add_card(deck[25]);
		
			break;
		case 1:
			draw_graphics("Hole Cards",0);
			draw_graphics("Flop",0);
									while (temp < players_count)
			{
				players[temp].add_card(deck[10]);
				players[temp].add_card(deck[11]);
				players[temp].add_card(deck[12]);
				temp = temp + 1;
			};
			break;
		case 2:
			draw_graphics("Hole Cards",0);
			draw_graphics("Flop",0);
			draw_graphics("Turn",0);
			while (temp < players_count)
			{
				players[temp].add_card(deck[13]);
				temp = temp + 1;
			};
			break;
		case 3:
			draw_graphics("Hole Cards",0);
			draw_graphics("Flop",0);
			draw_graphics("Turn",0);
			draw_graphics("River",0);
			while (temp < players_count)
			{
				players[temp].add_card(deck[14]);
				temp = temp + 1;
			};
			break;
	};
};


// Just some small variables deklared:
card *deck;
money_pot pot;

// -----------------------------------------------
//
// Function that outputs all the information that the current player has to the terminal. Same as above.

void round_info(int temppl, int round) {
	string inn;
	int temp;
	switch (round) {
	case 0:
		::cout<<"PL"<<temppl<<endl<<"Your cards: "<<endl;
		::cout<<players[temppl].eigen[0].sorte<<" "<<players[temppl].eigen[0].wert_txt<<" | "<<players[temppl].eigen[1].sorte<<" "<<players[temppl].eigen[1].wert_txt<<endl;
		::cout<<endl<<"Money in pot: "<<pot.money<<" | Money to bet: "<<pot.einsatz - players[temppl].einsatz<<endl;
		temp = 0;
		while ( temp < players_count )
		{
			if (!players[temp].is_in) {
				inn = "(OUT!)";
			} else {
				inn = "      ";
			};
			::cout<<"   "<<inn<<"   Bet & Money of Player Nr."<<temp<<": "<<players[temp].einsatz<<"/"<<players[temp].money<< "    "<<players[temp].name<<endl;
			temp = temp + 1;
		};
		break;
	case 1:
		::cout<<"PL"<<temppl<<endl<<"Your cards: ";
		::cout<<players[temppl].eigen[0].sorte<<" "<<players[temppl].eigen[0].wert_txt<<" | "<<players[temppl].eigen[1].sorte<<" "<<players[temppl].eigen[1].wert_txt<<endl;
		::cout<<"Community cards: "<<endl<<deck[10].sorte<<" "<<deck[10].wert_txt<<" | "<<deck[11].sorte<<" "<<deck[11].wert_txt<<" | "<<deck[12].sorte<<" "<<deck[12].wert_txt<<endl;
		::cout<<endl<<"Money in pot: "<<pot.money<<" | Money to bet: "<<pot.einsatz - players[temppl].einsatz<<endl;
		temp = 0;
		while ( temp < players_count )
		{
			if (!players[temp].is_in) {
				inn = "(OUT!)";
			} else {
				inn = "      ";
			};
			::cout<<"   "<<inn<<"   Bet & Money of Player Nr."<<temp<<": "<<players[temp].einsatz<<"/"<<players[temp].money<< "    "<<players[temp].name<<endl;
			temp = temp + 1;
		};
		break;
	case 2:
		::cout<<"PL"<<temppl<<endl<<"Your cards: ";
		::cout<<players[temppl].eigen[0].sorte<<" "<<players[temppl].eigen[0].wert_txt<<" | "<<players[temppl].eigen[1].sorte<<" "<<players[temppl].eigen[1].wert_txt<<endl;
		::cout<<"Community cards: "<<endl<<deck[10].sorte<<" "<<deck[10].wert_txt<<" | "<<deck[11].sorte<<" "<<deck[11].wert_txt<<" | "<<deck[12].sorte<<" "<<deck[12].wert_txt<<" | "<<deck[13].sorte<<" "<<deck[13].wert_txt<<endl;
		::cout<<endl<<"Money in pot: "<<pot.money<<" | Money to bet: "<<pot.einsatz - players[temppl].einsatz<<endl;
		temp = 0;
		while ( temp < players_count )
		{
			if (!players[temp].is_in) {
				inn = "(OUT!)";
			} else {
				inn = "      ";
			};
			::cout<<"   "<<inn<<"   Bet & Money of Player Nr."<<temp<<": "<<players[temp].einsatz<<"/"<<players[temp].money<< "    "<<players[temp].name<<endl;
			temp = temp + 1;
		};
		break;
	case 3:
		::cout<<"PL"<<temppl<<endl<<"Your cards: ";
		::cout<<players[temppl].eigen[0].sorte<<" "<<players[temppl].eigen[0].wert_txt<<" | "<<players[temppl].eigen[1].sorte<<" "<<players[temppl].eigen[1].wert_txt<<endl;
		::cout<<"Community cards: "<<endl<<deck[10].sorte<<" "<<deck[10].wert_txt<<" | "<<deck[11].sorte<<" "<<deck[11].wert_txt<<" | "<<deck[12].sorte<<" "<<deck[12].wert_txt<<" | "<<deck[13].sorte<<" "<<deck[13].wert_txt<<" | "<<deck[14].sorte<<" "<<deck[14].wert_txt<<endl;
		::cout<<endl<<"Money in pot: "<<pot.money<<" | Money to bet: "<<pot.einsatz - players[temppl].einsatz<<endl;
		temp = 0;
		while ( temp < players_count )
		{
			if (!players[temp].is_in) {
				inn = "(OUT!)";
			} else {
				inn = "      ";
			};
			::cout<<"   "<<inn<<"   Bet & Money of Player Nr."<<temp<<": "<<players[temp].einsatz<<"/"<<players[temp].money<< "    "<<players[temp].name<<endl;
			temp = temp + 1;
		};
		break;
	};
		
};



// -----------------------------------------------
//
// Function that plays a whole round. From the private cards dealed until to the points calculating and declaring the one who gets the money.

void play_round(TTF_Font *font = NULL, TTF_Font *font_bigger = NULL, bool output = true) 
{
	::cout<<"New Round"<<endl;
	int temp = 0;
	int temp2 = 0;
	int correct;
	bool another_go;
	another_go = false;
	current_round = 0;
	draw_graphics("Background",0);
	draw_text("Buttons", font);
	::cout<<"Drawn backgrounds & Buttons"<<endl;
	draw_text("Player Stats", font_bigger);
	draw_text("Money in Pot", font_bigger);
	draw_text("Enemy Stats", font);
	::cout<<"Drawn all stats"<<endl;
	draw_graphics("Enemy Cards",0);
	::cout<<"Drawn enemy cards"<<endl;
	SDL_Flip(screen);
	temp = 0;
	while (temp < players_count ) {
		if(players[temp].money < 1 && btournament ) {
			players[temp].is_in = false;
		};
			players[temp].last_action = " ";
		
		temp = temp + 1;
	};

	while ( current_round < 4 ) {
		if (output ) {::cout<<endl<<endl<<"------------ Round "<<current_round + 1<<" of betting begins ------------"<<endl<<endl;};
		
		temp = 0;
		while (temp < players_count ) {
			if ( players[temp].last_action != "Fold" ) {
				if(players[temp].money < 1 && btournament && current_round == 0 ) {
					players[temp].is_in = false;
				};
			players[temp].last_action = " ";
			};
			temp = temp + 1;
		};
		
		draw_graphics("Background",0);
		give_cards(deck,current_round);  
		draw_text("Buttons", font);
		draw_text("Player Stats", font_bigger);
		draw_text("Money in Pot", font_bigger);
		draw_text("Enemy Stats", font);
		draw_graphics("Enemy Cards",0);
		fold_players(9);
		temp = 0;
			while ( temp < players_count ) { // Allen Spielern wieder das bieten mglich machen.
				players[temp].has_betted = false;

				temp = temp + 1;
			};
			
		
			temp = dealer + 3;
			if ( temp >= players_count ) {
			temp = temp - players_count ;
			};
			
			another_go = false;
			while ( temp < players_count ) {
				if ( !players[temp].has_betted && players[temp].is_in ) {
					if (output && !players[temp].is_ai ) {round_info(temp,current_round);};
					correct = turn(players[temp], pot,current_round, font, font_bigger, output);
					if (correct == 1) {
						draw_graphics("Background",0);
						draw_cards();						
						draw_text("Buttons", font);
						draw_text("Player Stats", font_bigger);
						draw_text("Money in Pot", font_bigger);
						draw_text("Enemy Stats", font);
						draw_graphics("Enemy Cards",0);
						fold_players(9);
					} else if ( correct == 2) {
						another_go = true;
						draw_graphics("Background",0);
						draw_cards();		
						draw_text("Buttons", font);
						draw_text("Player Stats", font_bigger);
						draw_text("Money in Pot", font_bigger);
						draw_text("Enemy Stats", font);
						draw_graphics("Enemy Cards",0);				
						fold_players(9);
					} else if ( correct == 3) {
						another_go = false;
						temp = players_count;
						current_round = 5;
					} else { temp = temp - 1; if ( output ) ::cout<<endl<<"Incorrect Action"<<endl; };
				};
				
				temp = temp + 1;
				if ( temp == players_count ) {
					::cout<<"Palyer 7 has done his action"<<endl;
				
				temp2 = 0;
				int other_players = 0;
				while ( temp2 < players_count ) { // Allen Spielern wieder das bieten mglich machen.
					if (players[temp2].is_in ) {
						if (players[temp2].has_betted == false) {
						::cout<<"Somebody who hasn't betted found."<<endl;
						another_go = true;
						};
						other_players = other_players + 1;
					};
						
					temp2 = temp2 + 1;
				};
				
				if ( other_players == 1 ) {
					current_round = 7;
					another_go = false;
				};
				
				
				if (another_go) { // Alle Spieler haben eine Aktion gettigt und es ist eine weitere Runde ntig:
					::cout<<"So here we go again."<<endl;
					temp = 0;
					another_go = false;
				};
				};
			
			};
		current_round = current_round + 1;
	};
	
	temp = 0;
	while (temp < players_count ) {
		players[temp].last_action = " ";
		temp = temp + 1;
	};
	
	// Look who's the best.!
	if ( output ) {::cout<<endl<<endl<<"----------FINISHED-----------"<<endl<<endl;};

	
	temp = 0;
	int best_player = 0;
	int second_player = 20;
	int add_pl_count = 0;
	while ( temp < players_count ) {
			
		if ( players[temp].is_in ) {
			players[temp].points = get_points(players[temp].cards,false);
			
			switch (add_pl_count) {
				case 0:
					best_player = temp;
					break;
					
				case 1:
					if ( get_points(players[temp].cards, false, 7, true ) > get_points(players[best_player].cards, false, 7, true ) ) { 
						second_player = best_player;
						best_player = temp;
					} else { 
						if ( get_points(players[temp].cards, false, 7, true ) == get_points(players[best_player].cards, false, 7, true ) ) {
							if ( players[temp].points > players[best_player].points ) {
								second_player = best_player;
								best_player = temp;
							} else {
								second_player = temp;
							};
						} else {
							second_player = temp;
						};
					};
							
					break;
					
				default:
					if ( get_points(players[temp].cards, false, 7, true ) > get_points(players[best_player].cards, false, 7, true ) ) { 
						second_player = best_player;
						best_player = temp;
					} else { 
						if ( get_points(players[temp].cards, false, 7, true ) == get_points(players[best_player].cards, false, 7, true ) ) {
							if ( players[temp].points > players[best_player].points ) {
								second_player = best_player;
								best_player = temp;
							} else {
								
							
								if ( get_points(players[temp].cards, false, 7, true ) > get_points(players[second_player].cards, false, 7, true ) ) { 
									second_player = temp;
								} else { 
									if ( get_points(players[temp].cards, false, 7, true ) == get_points(players[second_player].cards, false, 7, true ) ) {
										if ( players[temp].points > players[second_player].points ) {
											second_player = temp;
										};
									}
								};
							};
						};
					};
					
					break;
			};
		add_pl_count = add_pl_count + 1;
		};
				
			
			
		temp = temp + 1;
			
	};
	
	if (players[0].money < 0 && btournament ) {
		goto_menu = true;
	};
		
	
	
	if ( players[best_player].points == players[second_player].points ) {
		players[best_player].money = players[best_player].money + pot.money/2;
		players[second_player].money = players[second_player].money + pot.money/2;
	} else {
		players[best_player].money = players[best_player].money + pot.money;
	};
	
	
	
	int text_x = 135;
	int text_y = 25;
	string hand_text;
	int cards_player_1_x = 90;
	int cards_player_2_x = 120;
	int cards_player_y = 70;
	int hand_player_y = cards_player_y - 17;
	int hand_player_x = cards_player_1_x;
	int name_player_y = hand_player_y - 12;
	int cards_ai_1_x = 175;
	int cards_ai_2_x = 205;
	int cards_ai_y = cards_player_y;
	int hand_ai_y = hand_player_y;
	int name_ai_y = name_player_y;
	int hand_ai_x = cards_ai_1_x;
	
	if ( players[0].is_in ) {
	
	blit(75,20,results_surf,screen, NULL);
	
	if ( best_player == pl_pointer[0] ) {
	
			switch(get_points(players[best_player].cards,true,7,true)) {
				case 0:
					hand_text = "High Card";
					break;
				case 1:
					hand_text = "One Pair";
					break;
				case 2:
					hand_text = "Two Pairs";
					break;
				case 3:
					hand_text = "Trips";
					break;
				case 4:
					hand_text = "Straight";
					break;
				case 5:
					hand_text = "Flush";
					break;
				case 6:
					hand_text = "Full House";
					break;
				case 7:
					hand_text = "Quads";
					break;
				case 8:
					hand_text = "Straight Flush";
					break;
			};
		if ( players[best_player].points == players[second_player].points ) {
			blit_text("Draw!", text_x, text_y,font_bigger);
		} else {
		blit_text("You won", text_x, text_y,font_bigger);
		};
		blit_text(hand_text, hand_player_x, hand_player_y,font);
		::cout<<"Art of hand blitted."<<endl;
		blit_text(players[best_player].name,hand_player_x,name_player_y,font );
		blit(cards_player_1_x, cards_player_y, card_surface, screen, &players[best_player].eigen[0].sprite_pos);
		blit(cards_player_2_x, cards_player_y, card_surface, screen, &players[best_player].eigen[1].sprite_pos);
		::cout<<"Cards blitted."<<endl;
											
		if (second_player<20) {
		switch(get_points(players[second_player].cards,true,7,true)) {
				case 0:
					hand_text = "High Card";
					break;
				case 1:
					hand_text = "One Pair";
					break;
				case 2:
					hand_text = "Two Pairs";
					break;
				case 3:
					hand_text = "Trips";
					break;
				case 4:
					hand_text = "Straight";
					break;
				case 5:
					hand_text = "Flush";
					break;
				case 6:
					hand_text = "Full House";
					break;
				case 7:
					hand_text = "Quads";
					break;
				case 8:
					hand_text = "Straight Flush";
					break;
		};
			::cout<<"Enemy got "<<hand_text<<endl;
			blit_text(players[second_player].name,hand_ai_x,name_player_y,font );
			blit_text(hand_text, hand_ai_x, hand_ai_y,font);
			::cout<<"Art of hand blitted."<<endl;
		blit(cards_ai_1_x, cards_ai_y, card_surface, screen, &players[second_player].eigen[0].sprite_pos);
		blit(cards_ai_2_x, cards_ai_y, card_surface, screen, &players[second_player].eigen[1].sprite_pos);
		::cout<<"Cards blitted."<<endl;
							
						
		};						
						
	} else {
		switch(get_points(players[pl_pointer[0]].cards,true,7,true)) {
			case 0:
				hand_text = "High Card";
				break;
			case 1:
				hand_text = "One Pair";
				break;
			case 2:
				hand_text = "Two Pairs";
				break;
			case 3:
				hand_text = "Trips";
				break;
			case 4:
				hand_text = "Straight";
				break;
			case 5:
				hand_text = "Flush";
				break;
			case 6:
				hand_text = "Full House";
				break;
			case 7:
				hand_text = "Quads";
				break;
			case 8:
				hand_text = "Straight Flush";
				break;
		};
		
		if ( players[best_player].points == players[0].points ) {
			blit_text("Draw!", text_x, text_y,font_bigger);
		} else {
			blit_text("You lost!", text_x, text_y,font_bigger);
		};		
		blit_text(hand_text, hand_player_x, hand_player_y,font);
		::cout<<"Art of hand blitted."<<endl;
		blit_text(players[pl_pointer[0]].name,hand_player_x,name_player_y,font );
		blit(cards_player_1_x, cards_player_y, card_surface, screen, &players[pl_pointer[0]].eigen[0].sprite_pos);
		blit(cards_player_2_x, cards_player_y, card_surface, screen, &players[pl_pointer[0]].eigen[1].sprite_pos);
		::cout<<"Cards blitted."<<endl;
		
		
		switch(get_points(players[best_player].cards,true,7,true)) {
			case 0:
				hand_text = "High Card";
				break;
			case 1:
				hand_text = "One Pair";
				break;
			case 2:
				hand_text = "Two Pairs";
				break;
			case 3:
				hand_text = "Trips";
				break;
			case 4:
				hand_text = "Straight";
				break;
			case 5:
				hand_text = "Flush";
				break;
			case 6:
				hand_text = "Full House";
				break;
			case 7:
				hand_text = "Quads";
				break;
			case 8:
				hand_text = "Straight Flush";
				break;
		};
		::cout<<"Enemy got "<<hand_text<<endl;
		blit_text(hand_text, hand_ai_x, hand_ai_y,font);
		::cout<<"Art of hand blitted."<<endl;
		blit_text(players[best_player].name,hand_ai_x,name_player_y,font );
		blit(cards_ai_1_x, cards_ai_y, card_surface, screen, &players[best_player].eigen[0].sprite_pos);
		blit(cards_ai_2_x, cards_ai_y, card_surface, screen, &players[best_player].eigen[1].sprite_pos);	
		::cout<<"Cards blitted."<<endl;
	};
	::cout<<"Before Delay"<<endl;
	SDL_Flip(screen);
	SDL_Event event;
	bool clicked = false;
	if (GP2X) {
		while(!clicked) {
			while (SDL_PollEvent(&event))
			{
				switch (event.type)
				{
					case SDL_JOYBUTTONDOWN:
						clicked = true;
						break;
				};
			};
		};
	} else {
		SDL_Delay(5000);
	};
	
	if ( btournament ) {
		if (players[0].is_in) {
			bool winner = true;
			int temp = 1;
			while ( temp < players_count ) {
				if ( players[temp].money > 0 ) {
					winner = false;
				}
				temp = temp + 1;
			};
		
			if ( winner ) {
			SDL_Surface *won_surf = load_image("data/won.gif");
			blit(0, 0, won_surf, screen, NULL);
			SDL_Flip(screen);
			SDL_Event event;
			bool clicked = false;
			if (GP2X) {
				while(!clicked) {
					while (SDL_PollEvent(&event))
					{
						switch (event.type)
						{
							case SDL_JOYBUTTONDOWN:
								switch(event.jbutton.button)
								{
									case GP2X_BUTTON_START:
										clicked = true;
										goto_menu = true;
										break;
								};
						};
					};
				};
			} else {
				SDL_Delay(delay*100);
			};
			};
		};
	};
	
	};
};


//----------------------------------------------------------------------
//----------------------------------------------------------------------
//   FUNCTIONS THAT WILL INITIALISE THINGS ARE FOLLOWING HERE
//----------------------------------------------------------------------
//----------------------------------------------------------------------


// -----------------------------------------------
//
// Function that initialises the basic game things. It builds the card base and gives all the players an amount of money.

void init_game()
{
	played_hands = 0;
	build_card_base();
	int temp = 0;
	while ( temp < players_count ) 
	{
		players[temp].money = start_money;
		temp = temp + 1;
	};
	draw_graphics("Background",0);
	SDL_Flip(screen);	
		
};

// -----------------------------------------------
//
// Function that resets the pot, builds a new deck etc. Should get called before a new play_round().

void new_round()
{
	bool dealer_in = false;
	::cout<<"New Round"<<endl;
	int count = 0;
	deck = build_deck();
	::cout<<"Deck Built"<<endl;
	::cout<<"Pot emptied"<<endl;
	int temp = 0;
	while(temp<players_count) {
		if (btournament) {
			if ( players[temp].money > 0 ) {
				players[temp].cardcount = 0;
				players[temp].last_action = "";
				players[temp].is_in = true;
				players[temp].einsatz = 0;
				count = count + 1;
				
			};
		} else {
			players[temp].cardcount = 0;
			players[temp].last_action = "";
			players[temp].is_in = true;
			players[temp].einsatz = 0;
			count = 8;
		};
		temp = temp + 1;
	};
	
	
	switch (count) {
		case 2:
			small_blind = 30;
			 big_blind = 60;
			 low_limit = 60;
			 high_limit = 120;
			break;
		case 3:
			 small_blind = 15;
			 big_blind = 30;
			 low_limit = 30;
			 high_limit = 60;
			break;
		case 4:
			 small_blind = 10;
			 big_blind = 20;
			 low_limit = 20;
			 high_limit = 40;
			break;
		default:
			 small_blind = 5;
			 big_blind = 10;
			 low_limit = 10;
			 high_limit = 20;
			break;
	};
			
			
		
	
	::cout<<"All players cardcount and poitns set_back and made all in."<<endl;
	
	while(!dealer_in) {
	dealer = dealer + 1;
	if( dealer == players_count ) {
		dealer = 0;
	};
	if (players[dealer].is_in) {
		dealer_in = true;
	};
	};
	pot.empty();
};

void get_coordinates() {
	cord_en_c[0].x = 11;
	cord_en_c[0].y = 49;
	cord_en_c[1].x = 57;
	cord_en_c[1].y = 49;
	cord_en_c[2].x = 103;
	cord_en_c[2].y = 49;
	cord_en_c[3].x = 149;
	cord_en_c[3].y = 49;
	cord_en_c[4].x = 195;
	cord_en_c[4].y = 49;
	cord_en_c[5].x = 241;
	cord_en_c[5].y = 49;
	cord_en_c[6].x = 287;
	cord_en_c[6].y = 49;
	
	cord_pl_c[0].x = 225;
	cord_pl_c[0].y = 195;
	cord_pl_c[1].x = 259;
	cord_pl_c[1].y = 195;
	
	cord_com_c[0].x = 87;
	cord_com_c[0].y = 138;
	cord_com_c[1].x = 118;
	cord_com_c[1].y = 138;
	cord_com_c[2].x = 149;
	cord_com_c[2].y = 138;
	cord_com_c[3].x = 180;
	cord_com_c[3].y = 138;
	cord_com_c[4].x = 211;
	cord_com_c[4].y = 138;
	
	en_cards[0].x = 27;
	en_cards[0].y = 156;
	en_cards[0].w = 19;
	en_cards[0].h = 26;
	en_cards[1].x = 46;
	en_cards[1].y = 156;
	en_cards[1].w = 19;
	en_cards[1].h = 26;
	
	cord_but_txt[0].x = 46;
	cord_but_txt[0].y = 195;
	cord_but_txt[1].x = 31;
	cord_but_txt[1].y = 217;
	cord_but_txt[2].x = 80;
	cord_but_txt[2].y = 217;
	
	cord_pl1_txt[0].x = 144;
	cord_pl1_txt[0].y = 189;
	cord_pl1_txt[1].x = 144;
	cord_pl1_txt[1].y = 204;
	cord_pl1_txt[2].x = 144;
	cord_pl1_txt[2].y = 219;
	
	cord_en_name[0].y = 6;
	cord_en_name[1].y = 6;
	cord_en_name[2].y = 6;
	cord_en_name[3].y = 6;
	cord_en_name[4].y = 6;
	cord_en_name[5].y = 6;
	cord_en_name[6].y = 6;
	cord_en_name[0].x = 7;
	cord_en_name[1].x = 53;
	cord_en_name[2].x = 100;
	cord_en_name[3].x = 145;
	cord_en_name[4].x = 191;
	cord_en_name[5].x = 237;
	cord_en_name[6].x = 283;
	
	cord_en_money[0].y = 19;
	cord_en_money[1].y = 19;
	cord_en_money[2].y = 19;
	cord_en_money[3].y = 19;
	cord_en_money[4].y = 19;
	cord_en_money[5].y = 19;
	cord_en_money[6].y = 19;
	cord_en_money[0].x = 7;
	cord_en_money[1].x = 53;
	cord_en_money[2].x = 100;
	cord_en_money[3].x = 145;
	cord_en_money[4].x = 191;
	cord_en_money[5].x = 237;
	cord_en_money[6].x = 283;
	
	cord_en_bet[0].y = 31;
	cord_en_bet[1].y = 31;
	cord_en_bet[2].y = 31;
	cord_en_bet[3].y = 31;
	cord_en_bet[4].y = 31;
	cord_en_bet[5].y = 31;
	cord_en_bet[6].y = 31;
	cord_en_bet[0].x = 7;
	cord_en_bet[1].x = 53;
	cord_en_bet[2].x = 100;
	cord_en_bet[3].x = 145;
	cord_en_bet[4].x = 191;
	cord_en_bet[5].x = 237;
	cord_en_bet[6].x = 283;
	
	cord_money_pot.x = 24;
	cord_money_pot.y = 142;
	::cout<<"Coordinates gotten"<<endl;
};

void fold_players(int whichone) {
	if ( players[pl_pointer[0]].is_in) {
		SDL_Delay(delay);
	};
	SDL_Rect temppos;
	temppos.w = 40;
	temppos.x = 252;
	temppos.h = 16;
	int temp_pl;
	if (whichone == 9 ) {
	temp_pl = 0;
	} else {
	temp_pl = whichone;
	};
	bool dontdraw = false;
	while ( temp_pl <= players_count ) {
		dontdraw = false;
			if (players[pl_pointer[temp_pl]].last_action != " ") {
				if ( players[pl_pointer[temp_pl]].is_in == false ) {
					temppos.y = 0;
				} else {
					if (players[pl_pointer[temp_pl]].last_action == "Check" ) {
						temppos.y = 30;
					} else if ( players[pl_pointer[temp_pl]].last_action == "Call") {
						temppos.y = 48;
					} else if ( players[pl_pointer[temp_pl]].last_action == "Raise") { 
						temppos.y = 16;
					} else {
						dontdraw = true;
					};
				};
				if (players[pl_pointer[temp_pl]].name == players_name ) {
					dontdraw = true;
				};
					if (!dontdraw) {
						blit( cord_en_c[temp_pl - 1].x - 14, cord_en_c[temp_pl - 1].y + 30, action_surf, screen, &temppos );
						
					};
			};
		if ( whichone == 9 ) {
			temp_pl = temp_pl + 1;
		} else {
			temp_pl = 10;
		};
	};
						SDL_Flip(screen);
	if ( players[pl_pointer[0]].is_in) {
		SDL_Delay(delay);
	};
};


//----------------------------------------------------------------------
//----------------------------------------------------------------------
//   FUNCTIONS THAT WILL GET USED WITH SDL ARE FOLLOWING HERE
//----------------------------------------------------------------------
//----------------------------------------------------------------------

// -----------------------------------------------
//
// Function that initialises all the sdl things. Necessary to get called.
 

void blit_text( string string, int x, int y, TTF_Font *font)
{
	SDL_Color foregroundColor = { 0, 0, 0 };
	SDL_Surface* textSurface =  TTF_RenderText_Blended(font,string.c_str(), foregroundColor);
	SDL_Rect textLocation = { x, y, 0, 0 };
	SDL_BlitSurface(textSurface, NULL, screen, &textLocation);
	SDL_FreeSurface(textSurface);
}


SDL_Surface *load_image( std::string filename ) 
{

    SDL_Surface* loadedImage = NULL;
    

    SDL_Surface* optimizedImage = NULL;
    

    loadedImage = IMG_Load( filename.c_str() );
	if (loadedImage == NULL ) {
	::cout<<"Couldn't load Image";
    };
	
	//With the transparencies we don't want to optimize the image, maybe this will get inserted as soon as I know how to use the color key corectly.
	

    if( loadedImage != NULL )
    {
		

        optimizedImage = SDL_DisplayFormatAlpha( loadedImage );
        


        SDL_FreeSurface( loadedImage );
    }
	
    

    return optimizedImage;
}

void blit( int x, int y, SDL_Surface* source, SDL_Surface* destination, SDL_Rect* clip = NULL )
{

    SDL_Rect coordinates;
    

    coordinates.x = x;
    coordinates.y = y;

    SDL_BlitSurface( source, clip, destination, &coordinates );
}

inline std::string to_string(double x)
{
	std::ostringstream o;
	o << x;
	return o.str();
}

//------------------------------------------------------------
//------------------------------------------------------------

int draw_graphics(string what, int which) {
	
	if ( what == "Background" ) {
			blit( 0, 0, background_surf, screen);
	} else if (what == "Hole Cards") {
			blit( cord_pl_c[0].x, cord_pl_c[0].y, card_surface, screen, &deck[30].sprite_pos);
			blit( cord_pl_c[1].x, cord_pl_c[1].y, card_surface, screen, &deck[1].sprite_pos);
	} else if ( what == "Flop" ) {
			blit( cord_com_c[0].x, cord_com_c[0].y, card_surface, screen, &deck[10].sprite_pos);
			blit( cord_com_c[1].x, cord_com_c[1].y, card_surface, screen, &deck[11].sprite_pos);
			blit( cord_com_c[2].x, cord_com_c[2].y, card_surface, screen, &deck[12].sprite_pos);
	} else if (what == "Turn" ) {
			blit( cord_com_c[3].x, cord_com_c[3].y, card_surface, screen, &deck[13].sprite_pos);
	} else if (what == "River" ) {
			blit( cord_com_c[4].x, cord_com_c[4].y, card_surface, screen, &deck[14].sprite_pos);
	} else if (what == "Enemy Cards" ) {
		if (players[pl_pointer[1]].is_in  && players_count >= 2) {
		blit( cord_en_c[0].x, cord_en_c[0].y, card_surface, screen, &en_cards[0]);
		};
		if (players[pl_pointer[2]].is_in  && players_count >= 3) {
			blit( cord_en_c[1].x, cord_en_c[1].y, card_surface, screen, &en_cards[0]);
		};
		if (players[pl_pointer[3]].is_in  && players_count >= 4) {
			blit( cord_en_c[2].x, cord_en_c[2].y, card_surface, screen, &en_cards[0]);
		};
		if (players[pl_pointer[4]].is_in  && players_count >= 5) {
			blit( cord_en_c[3].x, cord_en_c[3].y, card_surface, screen, &en_cards[0]);
		};
		if (players[pl_pointer[5]].is_in  && players_count >= 6) {
			blit( cord_en_c[4].x, cord_en_c[4].y, card_surface, screen, &en_cards[0]);
		};
		if (players[pl_pointer[6]].is_in  && players_count >= 7) {
			blit( cord_en_c[5].x, cord_en_c[5].y, card_surface, screen, &en_cards[0]);
		};
		if (players[pl_pointer[7]].is_in && players_count == 8) {
			blit( cord_en_c[6].x, cord_en_c[6].y, card_surface, screen, &en_cards[0]);
		};
	} else if (what == "Fold Enemy" ) {
		if ( which > 0 ) {
		blit( cord_en_c[which - 1].x, cord_en_c[which - 1].y, card_surface, screen, &en_cards[1]);
		};
	
	};
		
	return 1;
};

void draw_cards( ) {
	switch (current_round)
	{
		case 0:	
			draw_graphics("Hole Cards",0);
			draw_graphics("Enemy Cards",0);
			break;
		case 1:
			draw_graphics("Hole Cards",0);
			draw_graphics("Flop",0);
			break;
		case 2:
			draw_graphics("Hole Cards",0);
			draw_graphics("Flop",0);
			draw_graphics("Turn",0);
			break;
		case 3:
			draw_graphics("Hole Cards",0);
			draw_graphics("Flop",0);
			draw_graphics("Turn",0);
			draw_graphics("River",0);
			break;
	};
};
	

int draw_text(string what,TTF_Font *font) {

	if ( what == "Buttons" ) {
		int temp = pot.einsatz - players[pl_pointer[0]].einsatz;
		string temp_str, but_str;
		if ( players[pl_pointer[0]].einsatz == 80 ) {
			but_str = "Y-Check";
			blit_text(but_str,cord_but_txt[0].x - 1,cord_but_txt[0].y,font);
		} else if ( players[pl_pointer[0]].einsatz == 40 && current_round < 2 ) {
			but_str = "Y-Check";
			blit_text(but_str,cord_but_txt[0].x - 1,cord_but_txt[0].y,font);
		} else if ( temp > 0 ) {
			but_str = "Y-Call $" + to_string(temp);
			blit_text(but_str,cord_but_txt[0].x - 4,cord_but_txt[0].y,font);
		} else {
			but_str = "Y-Check";
			blit_text(but_str,cord_but_txt[0].x - 1,cord_but_txt[0].y,font);
		
		};	
		if ( pot.einsatz == 0 ) {
			blit_text("B-Bet",cord_but_txt[2].x - 1,cord_but_txt[2].y,font);
		} else if ( players[pl_pointer[0]].einsatz == 80 ) {
			blit_text("B-Check",cord_but_txt[2].x - 7,cord_but_txt[2].y,font);
		} else if ( players[pl_pointer[0]].einsatz == 40 && current_round < 2) {
			blit_text("B-Check",cord_but_txt[2].x - 7,cord_but_txt[2].y,font);
		} else {
			blit_text("B-Raise",cord_but_txt[2].x - 7,cord_but_txt[2].y,font);
		};
		blit_text("A-Fold",cord_but_txt[1].x - 7,cord_but_txt[1].y,font);
	} else if ( what == "Player Stats" ) {
		blit_text(players_name,cord_pl1_txt[0].x,cord_pl1_txt[0].y,font);
		blit_text("$" + to_string(players[pl_pointer[0]].money),cord_pl1_txt[1].x,cord_pl1_txt[1].y,font);
		blit_text("$" + to_string(players[pl_pointer[0]].einsatz),cord_pl1_txt[2].x,cord_pl1_txt[2].y,font);
	} else if ( what == "Money in Pot" ) {
		blit_text("Pot:  $" + to_string(pot.money),cord_money_pot.x,cord_money_pot.y,font);
		blit_text("Hands: " + to_string(played_hands),cord_money_pot.x - 5, cord_money_pot.y + 12,font);
	} else if (what == "Enemy Stats") {
		int temp = 1;
		while ( temp < players_count ) {
			if (btournament) {
				if ( players[temp].money > 0 ) {
					 blit_text(players[temp].name,cord_en_name[temp - 1].x,cord_en_name[temp - 1].y,font);
					 blit_text("$" + to_string(players[temp].money),cord_en_money[temp - 1].x,cord_en_money[temp - 1].y,font);
					 blit_text("$" + to_string(players[temp].einsatz),cord_en_bet[temp - 1].x,cord_en_bet[temp - 1].y,font);
				} else if ( players[temp].money < 1 && players[temp].is_in == false ) {
					blit_text(players[temp].name,cord_en_name[temp - 1].x,cord_en_name[temp - 1].y,font);
					blit_text("Out!",cord_en_money[temp - 1].x,cord_en_money[temp - 1].y,font);
				};
					
			} else {
				blit_text(players[temp].name,cord_en_name[temp - 1].x,cord_en_name[temp - 1].y,font);
				blit_text("$" + to_string(players[temp].money),cord_en_money[temp - 1].x,cord_en_money[temp - 1].y,font);
				blit_text("$" + to_string(players[temp].einsatz),cord_en_bet[temp - 1].x,cord_en_bet[temp - 1].y,font);
			};
			temp = temp + 1;
		};
		if ( dealer != 0 ) {
			blit (cord_en_bet[dealer-1].x + 20,cord_en_bet[dealer-1].y + 5, dealer_surf, screen, NULL);
			::cout<<"Dealer: "<<dealer<<endl;
		} else {
			blit (cord_pl1_txt[2].x + 20,cord_pl1_txt[2].y + 5, dealer_surf, screen, NULL);
		};
	};
	
	return 1;
};

void show_splash() {
	SDL_Surface *temp = NULL;
	temp = load_image(splash_file);
	if ( temp == NULL ) {
		::cout<<"Can't load splash!"<<endl;
	};
	blit( 0, 0, temp, screen);
		SDL_Flip(screen);	
		::cout<<"Splash screen showed!"<<endl;
		SDL_Event event;
		bool clicked = false;
		 if (GP2X) {
			 while(!clicked) {
				 while (SDL_PollEvent(&event))
				 {
					 switch (event.type)
					 {
						 case SDL_JOYBUTTONDOWN:
							 clicked = true;
							 break;
					 };
				 };
			 };
		 };
};

void draw_action( player playertemp, string action ) {
	int temp = 0;
	int wen = 0;
	int tempx, tempy;
	int sheety;
	SDL_Rect temppos;
	
	while ( temp < players_count ) {
		if ( players[pl_pointer[temp]].name == playertemp.name ) {
			if ( temp > 0 ) {
				wen = temp;
			} else {
				wen = 0;
			};
			temp = 20;
			
       };
	   temp = temp + 1;
	};
	::cout<<"Wen: "<<wen<<endl;
	   
    if ( wen > 0 ) {
		tempx = cord_en_c[wen - 1].x - 5;
		tempy = cord_en_c[wen - 1].y;
		::cout<<action<<" X = "<<tempx<<" Y = "<<tempy<<endl;
		if (action == "Fold") {
			sheety = 0;
		} else if ( action == "Call") {
			sheety = 48;
		} else if ( action == "Check" ) {
			sheety = 32;
		} else { //Raise
			sheety = 16;
		};
		temppos.x = 0;
		temppos.y = sheety;
		temppos.w = 28;
		temppos.h = 16;
		
		::cout<<"Blitting action: Action surface: "<<action_surf<<endl;
		blit( tempx, tempy, action_surf, screen, &temppos );
		SDL_Flip(screen);
		SDL_Delay(delay/6); 
	
		temppos.x = temppos.x + temppos.w;
		blit( tempx, tempy, action_surf, screen, &temppos );
		SDL_Flip(screen);
		SDL_Delay(delay/6);
	
	temppos.x = temppos.x + temppos.w;
	blit( tempx, tempy, action_surf, screen, &temppos );
	SDL_Flip(screen);
	SDL_Delay(delay/6); 
	
	temppos.x = temppos.x + temppos.w;
	blit( tempx, tempy, action_surf, screen, &temppos );
	SDL_Flip(screen);
	SDL_Delay(delay/6);
	
	temppos.x = temppos.x + temppos.w;
	blit( tempx, tempy, action_surf, screen, &temppos );
	SDL_Flip(screen);
	SDL_Delay(delay/6);
	
	temppos.x = temppos.x + temppos.w; 
	blit( tempx, tempy, action_surf, screen, &temppos );
	SDL_Flip(screen);
	SDL_Delay(delay/6);
	
	temppos.x = temppos.x + temppos.w;
	blit( tempx, tempy, action_surf, screen, &temppos );
	SDL_Flip(screen);
	SDL_Delay(delay/6); 
	
	temppos.x = temppos.x + temppos.w;
	blit( tempx, tempy, action_surf, screen, &temppos );
	SDL_Flip(screen);
	SDL_Delay(delay/6);
	
	temppos.x = temppos.x + temppos.w;
	blit( tempx, tempy, action_surf, screen, &temppos );
	SDL_Flip(screen);
	SDL_Delay(delay*2);
	
	
};



};

void read_config () {
	char temp[256];
	if (config_file.is_open()) {
		::cout<<"Config File loaded"<<endl;
		config_file.ignore(28,']');
		char c;
		while (config_file.good())  
		{
			c = config_file.get();       // get character from file
			if ( c == 'b' ) {
				::cout<<"Background found!"<<endl;
				config_file.ignore(20,' ');
				config_file.getline(temp,100);
				backgrounds[back_count] = temp;
				back_count += 1;
				
			} else if ( c == 'c' ) {
				::cout<<"Cardset found!"<<endl;
				config_file.ignore(20,' ');
			
				config_file.getline(temp,100);
				cardsets[card_count] = temp;
				card_count += 1;
				
			
			}	else if ( c == 'm' ) {
					::cout<<"Music found!"<<endl;
					config_file.ignore(20,' ');
					
					config_file.getline(temp,100);
					music_tracks[music_count] = temp;
					music_count = music_count + 1;
			};
		}
		backgrounds[back_count] = "";
		cardsets[card_count] = "";
		music_tracks[music_count] = "";
	} else {
		::cout<<"Error loading config file. Using standart background and cards"<<endl;
		backgrounds[0] = "background_fusion_power.png";
		backgrounds[1] = "";
		cardsets[0] = "cards.gif";
		cardsets[1] = "";
	};
	
};


void menu() {

	SDL_Surface *menu_screen;
	SDL_Surface *selector;
	string speed[4];
	speed[0] = "Lightning";
	speed[1] = "Fast";
	speed[2] = "Medium";
	speed[3] = "Slow";
	string players_t[6];
	players_t[0] = "3";
	players_t[1] = "4";
	players_t[2] = "5";
	players_t[3] = "6";
	players_t[4] = "7";
	players_t[5] = "8";
	
	int curr_item = 0;
	int curr_back = 0, curr_cards = 0, curr_speed = 1, curr_pls = 5;
	
	int sel_left_x = 25;
	int sel_right_x = 185;
	int value_right_x = 185;
	
	//Correct
	int train_x = sel_left_x;
	int train_y = 143;
	int tourn_x = sel_left_x;
	int tourn_y = 186;
	
	//All but selectors correct.
	int back_x = value_right_x;
	int back_y = 142;
	int sel_back_x = sel_right_x;
	int sel_back_y = 133;
	
	int card_x = value_right_x;
	int card_y = 168;
	int sel_card_x = sel_right_x;
	int sel_card_y = 159;
	
	int speed_x = value_right_x;
	int speed_y = 195;
	int sel_speed_x = sel_right_x;
	int sel_speed_y = 186;
	
	int pl_x = value_right_x;
	int pl_y = 224;
	int sel_pl_x = sel_right_x;
	int sel_pl_y = 215;
	
	menu_screen = load_image("data/menu.png");
	selector = load_image("data/selector.png");
	
	TTF_Font *font;
	font = TTF_OpenFont(font_file.c_str(),10);
	
	blit(0,0,menu_screen,screen,NULL);
	
	blit_text(backgrounds[curr_back],back_x,back_y,font);
	blit_text(cardsets[curr_cards],card_x,card_y,font);
	blit_text(speed[curr_speed],speed_x,speed_y,font);
	blit_text(players_t[curr_pls],pl_x,pl_y,font);
	blit(sel_back_x,sel_back_y,selector,screen,NULL);
	

	SDL_Flip(screen);
	
	if (GP2X) {
	
	bool received = false;
	while(!received) {
		while (SDL_PollEvent(&event))
		{
			switch (event.type)
			{
				case SDL_JOYBUTTONDOWN:
					switch(event.jbutton.button)
					{
						case GP2X_BUTTON_A:
							::cout<<"A Pressed"<<endl;
							if (curr_item == 1 ) {
								if ( backgrounds[curr_back + 1] != "" ) {
									curr_back = curr_back + 1;
								};
							} else if (curr_item == 2 ) {
								
								if ( cardsets[curr_cards + 1] != "" ) {
									curr_cards = curr_cards + 1;
								};
							} else if (curr_item == 3 ) {
								
								if ( curr_speed < 3 ) {
									curr_speed = curr_speed + 1;
								};
							} else if (curr_item == 4 ) {
								
								if ( curr_pls < 5 ) {
									curr_pls = curr_pls + 1;
								};
							};
							break;
						case GP2X_BUTTON_Y:
							::cout<<"Y Pressed"<<endl;
							if (curr_item == 1 ) {
								if (curr_back > 0) {
									curr_back = curr_back - 1;
								};
									
							} else if (curr_item == 2 ) {
								
								if (curr_cards > 0) {
									curr_cards = curr_cards - 1;
								};
							} else if (curr_item == 3 ) {
								
								if (curr_speed > 0) {
									curr_speed = curr_speed - 1;
								};
							} else if (curr_item == 4 ) {
								
								if (curr_pls > 0) {
									curr_pls = curr_pls - 1;
								};
							}
							break;
						case GP2X_BUTTON_B:
							::cout<<"B Pressed"<<endl;
							if ( curr_item == 0 ) {
								btournament = false;
								received = true;
							} else if ( curr_item == 5 ) {
									btournament = true;
									received = true;
							};
							break;
						case GP2X_BUTTON_START:
							received = true;
							TTF_CloseFont(font);
							::cout<<"Font closed"<<endl;
							Mix_FreeMusic( music );
							::cout<<"Music freed"<<endl;
							Mix_CloseAudio();
							::cout<<"Audio closed"<<endl;
							TTF_Quit();
							::cout<<"TTF quit"<<endl;
							SDL_Quit();
							::cout<<"SDL quit"<<endl;
							chdir("/usr/gp2x");
							execl("./gp2xmenu", "./gp2xmenu", NULL);
							
							break;
						case GP2X_BUTTON_DOWN:
							::cout<<"Down Pressed"<<endl;
							if (curr_item == 0 ) {
								curr_item = 5;
								btournament = true;
							} else if ( curr_item != 4 && curr_item != 5 ) {
								if ( curr_item == 1 ) {
									curr_item = 2;
								} else if ( curr_item == 2 ) {
									curr_item = 3;
								} else {
									curr_item = curr_item + 1;
								};
							};
							break;
						case GP2X_BUTTON_UP:
							::cout<<"Up Pressed"<<endl;
							if (curr_item == 5 ) {
								curr_item = 0;
								btournament = false;
							} else  if (curr_item != 1 && curr_item != 0 ) {
								if (curr_item == 4 ) {
									curr_item = 3;
								} else if ( curr_item == 3 ) {
									curr_item = 2;
								} else {
								curr_item = curr_item - 1;
								};
							};
							break;
						case GP2X_BUTTON_LEFT:
							::cout<<"Left Pressed"<<endl;
							curr_item = 0;
							btournament = false;
							break;
						case GP2X_BUTTON_RIGHT:
							::cout<<"Right Pressed"<<endl;
							if ( curr_item == 0 ) {
								btournament = false;
								curr_item = 1;
							} else if ( curr_item == 5 ) {
								btournament = true;
								curr_item = 3;
							};
							break;
						case GP2X_BUTTON_VOLUP:
							::cout<<"VolUp pressed"<<endl;
							if ( music_volume < 120 ) {
								music_volume = music_volume + 10;
								Mix_VolumeMusic(music_volume);
							};
							break;
						case GP2X_BUTTON_VOLDOWN:
							::cout<<"VolUp pressed"<<endl;
							if ( music_volume > 0 ) {
								music_volume = music_volume - 10;
								Mix_VolumeMusic(music_volume);
							};
							break;
					
					};
					blit(0,0,menu_screen,screen,NULL);
					
					blit_text(backgrounds[curr_back],back_x,back_y,font);
					blit_text(cardsets[curr_cards],card_x,card_y,font);
					blit_text(speed[curr_speed],speed_x,speed_y,font);
					blit_text(players_t[curr_pls],pl_x,pl_y,font);
					
					switch (curr_item) {
						case 0:
							blit(train_x,train_y,selector,screen,NULL);
							break;
						case 1:
							blit(sel_back_x,sel_back_y,selector,screen,NULL);
							break;
						case 2:
							blit(sel_card_x,sel_card_y,selector,screen,NULL);
							break;
						case 3:
							blit(sel_speed_x,sel_speed_y,selector,screen,NULL);
							break;
						case 4:
							blit(sel_pl_x,sel_pl_y,selector,screen,NULL);
							break;
						case 5:
							blit(tourn_x,tourn_y,selector,screen,NULL);
							break;
					};
					
					SDL_Flip(screen);
					break;
			};
		};
	};
		
	players_count = 3 + curr_pls;
	switch (curr_speed) {
		case 0:
			delay = 10;
			break;
		case 1:
			delay = 150;
			break;
		case 2:
			delay = 300;
			break;
		case 3:
			delay = 500;
			break;
	};
	
	
	
	background_file = "data/" + backgrounds[curr_back];
	card_file = "data/" + cardsets[curr_cards];
	
	} else {
		SDL_Delay(8000);
		SDL_Quit();
	};
	
	goto_menu = false;
};
	
void musicFinished() {
	if ( current_song < music_count - 1 ) {
		current_song = current_song + 1;
	} else {
		current_song = 0;
	};
		

		music = Mix_LoadMUS(music_tracks[current_song].c_str());
		cout<<music_tracks[current_song].c_str()<<" and music is "<<music<<" "<<endl;
		Mix_PlayMusic(music,1);
};


//------------------------------------------------------------
//------------------------------------------------------------


int main( int argc, char* args[] )
{
	

	play_music = true;

    if( SDL_Init( SDL_INIT_EVERYTHING ) == -1 )
    {
        return 1;    
    }
    if(SDL_Init(SDL_INIT_AUDIO)==-1) {
		::cout<<"SDL_Init: "<<SDL_GetError()<<endl;
	}

    screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_HWSURFACE | SDL_DOUBLEBUF);
    
	
	
	if (SDL_JoystickOpen(0)) {
		SDL_ShowCursor (0);
		GP2X = true;
	};
	

    if( screen == NULL )
    {
        return 1;    
    }

	if(TTF_Init()==-1) {
		printf("TTF_Init: %s\n", TTF_GetError());
		exit(2);
	}

	
	TTF_Font *font;

	font = TTF_OpenFont(font_file.c_str(),11);

	
	TTF_Font *font_bigger;
	
	font_bigger = TTF_OpenFont(font_file_big.c_str(),11);
	
	//TTF_SetFontStyle(font_bigger, TTF_STYLE_BOLD);
	
	
	Mix_OpenAudio( 22050, AUDIO_S16, 2, 256 );
	Mix_Music *music = NULL;
	
	
	
	read_config();
	
	show_splash();
	

	
	music = Mix_LoadMUS(music_tracks[0].c_str());
	if( music == NULL ) {
		::cout<<"No music loaded! "<<Mix_GetError()<<endl;
	play_music = false;
	};
		
	if(play_music) {
		::cout<<music_tracks[current_song].c_str()<<" and music is "<<music<<" "<<Mix_GetError()<<endl;
	Mix_VolumeMusic(music_volume);
	::cout<<"Volume changed to "<<music_volume<<endl;
	
	if (Mix_PlayMusic(music,1) == -1 ) {
		::cout<<"Error playing music: "<<Mix_GetError()<<endl;
	};
	::cout<<"Music started playing"<<endl;
	Mix_HookMusicFinished(musicFinished);
	::cout<<"HookMusik assigned."<<endl;
	};
	
	
	while (true) {
		if (GP2X) {
			menu();
		};
		
	card_surface = load_image(card_file);
	background_surf = load_image(background_file);
	action_surf = load_image(action_file);
	results_surf = load_image(results_file);
	dealer_surf = load_image(dealer_file);
	
	player sieger;
	
	get_coordinates();
	
	init_game(); 
	new_round();
	generate_players();
	
	
	
	/*play_round(font, font_bigger);
	new_round();
	play_round(font, font_bigger);
	*/
	
	if (play_music) {
		cout<<music_tracks[current_song].c_str()<<" and music is "<<music<<" "<<Mix_GetError()<<" is it playing? "<<Mix_PlayingMusic()<<endl;
	if (!Mix_PlayingMusic()) {
		::cout<<"No Music playing"<<endl;
	//if (Mix_PlayMusic(music,1) == -1 ) {
		//::cout<<"ERROR AT MIXER: "<<Mix_GetError()<<endl;
	//};
	};
	};
	while(!goto_menu) {

		new_round();
		play_round(font, font_bigger, true);
		played_hands = played_hands + 1;
	};
	};
		 
    
    TTF_CloseFont(font);
    TTF_CloseFont(font_bigger);
	chdir("/usr/gp2x");
	execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);
    
	SDL_Quit();
	
	return 0; 
	   
};
